/*
*  Copyright 2022 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef DATATYPEDEF_H
#define DATATYPEDEF_H
typedef signed char         INT8, *PINT8;
typedef signed short        INT16, *PINT16;
typedef signed int          INT32, *PINT32;
typedef unsigned char       UINT8, *PUINT8;
typedef unsigned short      UINT16, *PUINT16;
typedef unsigned int        UINT32, *PUINT32;
typedef unsigned long int UINT64,*PULONG64;

enum {
    TCon = 0,
    TFunc = 1,
    TPred = 2,
    TEqn = 3,
    TNegEqn = 4,
    TNegPred = 5,
    TPairPred = 7
};

enum FILETYPE{TPTP,FOF,MYDefine};
enum RESULT
{
    READERR = -101, READOK, UNSAT = 100, SAT, UNKNOWN, NOCLAUSE = 0, ERR_STARTID = 200, ERR_NET, ERR_OUTFOLDER, ERR_INVOKE, UnknownFile,
    MOREFUNC, MORELIT, NOLEFTLIT, SingleLit, TAUTOLOGY, EqnTautology, RSubsump, RULEOK, NOMGU
    ,Succes,fail
};
#define Set1stTProp(va,prop)(va=(va)|(prop<<24))  
#define Del1stTProp(va,prop)(va=(va)&(prop<<24))  
#define Query1stTProp(va,prop)(((va>>24)&prop)==(prop))  
#define QueryCodeProp(va,prop)((va&prop)==(prop))  
#define Get1stTermID(va)(va&0xFFFFFF)    
#define GetCodeProp(va)(va>>24)     
#define EncodeVar(row,col) ((row<<8|col)|0x80000000) 
#define EncodeCon(va)(va=(va)|(TCon<<24))   
#define EncodeLitCode(row,col) (row<<8|col)   
#define IsVar(va)(va->iTermCode<0)     
#define GetVarRow(va)((va<<1)>>9)
#define GetClaId(va) ((va<<1)>>9)
#define GetVarId(va)(va&0xFF)
#define IsCon(va)((va>>28)==1)
#define GetCodeId(va)(va&0xFFFFFF)    

enum BACKTYPE{ NOBACK, CHGLIT, CHGNEXT };
typedef signed int LONG32, *PLONG32;
typedef unsigned int ULONG32, *PULONG32;
typedef unsigned long DWORD;

#define MAXUINT8    ((UINT8)~((UINT8)0))
#define MAXINT8     ((INT8)(MAXUINT8 >> 1))
#define MININT8     ((INT8)~MAXINT8)

#define MAXUINT16   ((UINT16)~((UINT16)0))
#define MAXINT16    ((INT16)(MAXUINT16 >> 1))
#define MININT16    ((INT16)~MAXINT16)

#define MAXUINT32   ((UINT32)~((UINT32)0))
#define MAXINT32    ((INT32)(MAXUINT32 >> 1))
#define MININT32    ((INT32)~MAXINT32)

#define MAXUINT64   ((UINT64)~((UINT64)0))
#define MAXINT64    ((INT64)(MAXUINT64 >> 1))
#define MININT64    ((INT64)~MAXINT64)

#define MAXULONG32  ((ULONG32)~((ULONG32)0))
#define MAXLONG32   ((LONG32)(MAXULONG32 >> 1))
#define MINLONG32   ((LONG32)~MAXLONG32)

#define MAXULONG64  ((ULONG64)~((ULONG64)0))
#define MAXLONG64   ((LONG64)(MAXULONG64 >> 1))
#define MINLONG64   ((LONG64)~MAXLONG64)

#define MAXULONGLONG ((ULONGLONG)~((ULONGLONG)0))
#define MINLONGLONG ((LONGLONG)~MAXLONGLONG)

#define MAXSIZE_T   ((SIZE_T)~((SIZE_T)0))
#define MAXSSIZE_T  ((SSIZE_T)(MAXSIZE_T >> 1))
#define MINSSIZE_T  ((SSIZE_T)~MAXSSIZE_T)

#define MAXUINT     ((UINT)~((UINT)0))
#define MAXINT      ((INT)(MAXUINT >> 1))
#define MININT      ((INT)~MAXINT)

#define MAXDWORD32  ((DWORD32)~((DWORD32)0))
#define MAXDWORD64  ((DWORD64)~((DWORD64)0))


typedef enum {
    noState,
    noused,
    used,
    noPiredSingle,
    PiredSingle,
    CopyTemp,
} ClaState;
typedef enum {
    noSt,
    isCon,
    isShareVar,
    isSingleVar,
    noSt_CSC,
    isCon_CSC,
    isShareVar_CSC,
    isSingleVar_CSC,
} termState;

#define P_SPLIT_CAHR '+' 
#define Id_SPLIT_CAHR ' '  
#define litWeight 5 
#define litSize 8
#endif /* DATATYPEDEF_H */

