/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef CLAUSE_H
#define CLAUSE_H
#include"dataTypeDef.h"
#include"HashNode.h"
#include "Literal.h"
#include "HashTree.h"
#include"globalFunc.h"
#include "StrategyParam.h"
class Clause {
    set<HashNode*, HashNodeCmpByCode> setHashTree;
public:
    UINT32 uClaId; 
    Literal** LitPtr; 
    map<INT32, Term*> mapSharedVars;
    float Priority;
    UINT16 uLitNum; 
    UINT16 uVarCount; 	
    UINT16 uFuncDepth; 
    UINT16 uReuseTimes;
    UINT32 adeductNum;
    UINT32 pdeductNum;
    bool isSDeduct;
    UINT32 reduntTimes; 
    bool isUse;
    bool isAxtom;
    bool isGoal;
    bool isPureCla;
    ClaState clast;
    int noUnitDeductTimes;
    bool demodulator;
    bool orgCla;
    UINT8 goaldeepth;
    UINT8 deduceDeepth;
    Literal* copyFrom;
    Literal* copyTo;
    Clause* topCopyCla;
    bool noPairResFiFg;
    UINT32 maxPred;
    UINT32 minPred;
    UINT32 maxPairPred;
    UINT32 minPairPred;
    UINT8 claAttr;
    UINT16 termCount12;
    UINT16 termCount11;
    UINT16 termCount21;
    Clause(vector<string>&vectsLit, UINT32 _claId);
    UINT32 FstTermCode(char*& ch);
    Term* GenerateTerm(char*& sLit);
    Clause(UINT32 _claId, UINT16 _reUseTimes) : Priority(0), uLitNum(0), uVarCount(0), uFuncDepth(0), uReuseTimes(_reUseTimes),adeductNum(0),pdeductNum(0),isSDeduct(false),reduntTimes(0),
    isUse(false),isAxtom(false),isGoal(false),isPureCla(false),clast(noState),demodulator(false),orgCla(false),goaldeepth(litWeight),deduceDeepth(0),copyFrom(nullptr),copyTo(nullptr),topCopyCla(nullptr),
    noPairResFiFg(false),maxPred(0),minPred(0),maxPairPred(0),minPairPred(0),claAttr(0),termCount12(0),termCount11(0),termCount21(0){		 
        uClaId = _claId | (_reUseTimes << 28);
        noUnitDeductTimes = 0;
    };
    void DelLits(bool isDelPred = true);
    void DelOneLit(Literal* lit, bool isDelPred = true);  
    Clause();
    Clause(const Clause& orig);
    virtual ~Clause();
    inline UINT32 MaxVarId() const {
        return mapSharedVars.size();
    }
    void SortLit();
    void SortLitDuct();
    void toString(string&str);
    void addRForCompetiton();
    void toPureString(string&sCla);
    void Print();
    int compFuncDeepthCla();
    bool HasTermBind();
    void initOrgClaAttr();
    UINT32 countClaTermE(UINT8 funCoff, UINT8 varCoff);
    void exEqnTerm();
    void directEqn();
    Term* VBInsert(INT32 iVarCode, UINT16&uMaxVarId) {
        uMaxVarId = 0;
        if (mapSharedVars.find(iVarCode) == mapSharedVars.end()) {
            uMaxVarId = mapSharedVars.size() + 1;
            Term* newT = new Term(); 
            newT->uVarCount = 1;
            newT->uMaxVarId = uMaxVarId;
            newT->termSt = isSingleVar;
            mapSharedVars.insert(make_pair(iVarCode, newT));			
        }
        else
            mapSharedVars[iVarCode]->termSt = isShareVar;
        return mapSharedVars[iVarCode];

    }
    inline Term* InsertVarFuncTerm(Term* newSubT) {
        return HashTree::InsertHashTree(newSubT, setHashTree);
    }
    inline bool hasConLit(){
        for(int m=0;m<uLitNum;m++){
            if(!(LitPtr[m]->isShareVarLiteral()))
                return true;
        }
        return false;
    }
    inline bool hasSamePredict(){
        if(uLitNum == 1)
            return false;
        for(int m=0;m<uLitNum-1;m++){
            for(int n=m+1;n<uLitNum;n++){
                if(LitPtr[m]->subTerm->iTermCode == LitPtr[n]->subTerm->iTermCode){
                    return true;
                }
            }
        }
        return false;
    }
    inline int hasUsed() const{
        if(isUse)
            return 1;
        else 
            return 0;
    }
    inline bool isUintEqn(){
        if(uLitNum != 1)
            return false;
        else if(GetCodeProp(LitPtr[0]->subTerm->iTermCode) == TEqn) 
            return true;
        else
            return false;
    }
    inline bool isequEqn(){
        if((uLitNum == 1) &&(GetCodeProp(LitPtr[0]->subTerm->iTermCode) ==TEqn) && (LitPtr[0]->subTerm->subTermPtr[0] == LitPtr[0]->subTerm->subTermPtr[1]))
            return true;
        else
            return false;
    }
    inline bool isSimplyEqn(){
        if((uLitNum == 1) &&(GetCodeProp(LitPtr[0]->subTerm->iTermCode) ==TEqn)){
             Term* left = LitPtr[0]->subTerm->subTermPtr[0];
             Term* right = LitPtr[0]->subTerm->subTermPtr[1];
             UINT32 leftTerm = 0;
             UINT32 rightTerm = 0;
             left->countTerm(leftTerm);
             right->countTerm(rightTerm);
             if((leftTerm - rightTerm) >= 3)
                return true;
             else
                 return false;
        }
        else
            return false;
    }
    inline bool hasOnlyNegEqn(){
        int n = 0;
        for(int m=0;m<uLitNum;m++){
            if(LitPtr[m]->subTerm->isNegEqnTerm()){
                ++n;
            }
        }
        if(n==1)
            return true;
        else
            return false;
    }
    inline bool hasNegEqn() {
        for (int m = 0; m < uLitNum; m++) {
            if (LitPtr[m]->subTerm->isNegEqnTerm()) {
                return true;
            }
        }
        return false;
    }
    inline bool hasEqn() {
        for (int m = 0; m < uLitNum; m++) {
            if (LitPtr[m]->subTerm->isNegEqnTerm() || LitPtr[m]->subTerm->isPosEqnTerm()) {
                return true;
            }
        }
        return false;
    }
    inline bool hasPLit(){
        for(int m=0;m<uLitNum;m++){
            if(LitPtr[m]->subTerm->isPLitTerm()){
                return true;
            }
        }
        return false;
    }
    inline bool isGoalCla(){
        int countLit=0;
        for(int m=0;m<uLitNum;m++){
            if(LitPtr[m]->subTerm->isNegLit()){
                ++countLit;
            }
        }
        if(countLit == uLitNum)
            return true;
        else
            return false;
    }
    inline bool judgeGoalCla(){
        for(int i=0;i<StrategyParam::goalClaId.size();++i){
            if(uClaId == StrategyParam::goalClaId[i]){
                return true;
            }
        }
        return false;
    }
};

class claCmpById : greater<Clause*> {
public:

    bool operator()(Clause* c1, Clause* c2) const {
        return c1->uClaId < c2->uClaId;
    }
};

class claCmpDeductNum : greater<Clause*> {
public:

    bool operator()(Clause* c1, Clause* c2) const {
        if(c1->adeductNum == c2->adeductNum)
        {
             if (c1->MaxVarId() == c2->MaxVarId()) {
                if (c1->uFuncDepth == c2->uFuncDepth)
                    return int(rand())%2 != int(rand())%2;
                return c1->uFuncDepth < c2->uFuncDepth;
            }
            return c1->MaxVarId() < c2->MaxVarId();
        }
        return c1->adeductNum < c2->adeductNum;
    }
}; 

class claCmpByRule : greater<Clause*> {
public:
    bool operator()(Clause* c1, Clause* c2) const {
        if (c1->uLitNum == c2->uLitNum) {
            if (c1->MaxVarId() == c2->MaxVarId()) {
                if (c1->uFuncDepth == c2->uFuncDepth)
                    return c1->uClaId < c2->uClaId;
                return c1->uFuncDepth < c2->uFuncDepth;
            }
            return c1->MaxVarId() < c2->MaxVarId();
        }
        return c1->uLitNum < c2->uLitNum;
    }
};

class claCmpPDeductNum : greater<Clause*> {
public:

    bool operator()(Clause* c1, Clause* c2) const {
        if (c1->pdeductNum == c2->pdeductNum) {
            if (c1->uLitNum == c2->uLitNum) {
                if (c1->MaxVarId() == c2->MaxVarId()) {
                    if (c1->uFuncDepth == c2->uFuncDepth)
                        return c1->uClaId < c2->uClaId;
                    return c1->uFuncDepth < c2->uFuncDepth;
                }
                return c1->MaxVarId() < c2->MaxVarId();
            }
            return c1->uLitNum < c2->uLitNum;
        }
        return c1->pdeductNum < c2->pdeductNum;
    }
}; 
#endif /* CLAUSE_H */

