/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#include "DataStructure.h"
#include "RedundancyOp.h"
#include "Clause.h"
#include "Literal.h"
#include "Term.h"

DataStructure::DataStructure() {
}

DataStructure::DataStructure(const DataStructure& orig) {
}

DataStructure::~DataStructure() {
}

RESULT DataStructure::GenerateCNF() {
    switch (FileOp::fileType) {
        case TPTP:
            return ReadTPTPFile();
        case FOF: break;
        case MYDefine:
        default: break;
    }
}

RESULT DataStructure::ReadTPTPFile()
{
    string strClause;
    uOrigClaSize = 1; 
    ifstream ifFolFile(FileOp::JudgeFileFullName.c_str(),ifstream::in);
    string strINFO;
    int iBracketNum = 0;
    vector< vector<string> >  vEqn;
    bool isAxiom = false;
    while (getline(ifFolFile, strClause)) {
        strClause = InitFunction::TrimStr(strClause); 
        if (strClause.length() == 0 || strClause[0] == '%') continue; 
        vector<string>vectLit; 
        if (strClause[0] == 'c') 
        {
            int index = strClause.find("clause", 3);
            isAxiom = (index == -1);
            iBracketNum = 1;
            continue;
        }
        if (iBracketNum > 0) {
            bool isEqnLit = false;
            bool isFinish = false;
            string strLit;
            for (int i = 0; i < strClause.length(); ++i) {
                if (isFinish)break;
                if (strClause[i] == ' ')continue; 
                if (strClause[i] == '(') {
                    if (iBracketNum > 1) strLit += '(';
                    ++iBracketNum;
                    while (strClause[++i] == ' ') {
                    }
                    if (strClause[i] >= '0' && strClause[i] <= '9') {
                        strLit += "a" + InitFunction::to_String(200 + strClause[i] - '0' + 1);
                        i++;
                    }
                }
                if (strClause[i] == ',') {
                    strLit += strClause[i];
                    while (strClause[++i] == ' ') {
                    }
                    if (strClause[i] >= '0' && strClause[i] <= '9') {
                        strLit += "a" + InitFunction::to_String(200 + strClause[i] - '0' + 1);
                        i++;
                    }
                }
                if (strClause[i] == ')')--iBracketNum;
                if (strClause[i] == '|' || iBracketNum == 1) {
                    if (isEqnLit) {
                        strLit += ')';
                        isEqnLit = false;
                    }
                    if (strLit.find('(') == -1) {
                        strLit += "(a)";
                    }
                    int iPosA = strLit.find("$true");
                    int iPosB = strLit.find("~$false");
                    if (iPosA>-1 || iPosB>-1) 
                    {
                        strLit = "";
                        i = strClause.length();
                        continue;
                    }
                    iPosA = strLit.find("~$true");
                    iPosB = strLit.find("$false");
                    if (!(iPosA>-1)&&!(iPosB>-1))
                    {
                        vectLit.push_back(strLit);
                    }
                    strLit = "";
                    if (strClause[i] == '|')continue;
                }
                if (iBracketNum == 1) {
                    isFinish = true;
                    if (isAxiom) 
                    {
                        vEqn.push_back(vectLit);
                        break;
                    }
                    if (vectLit.size() > 1 && RedundancyOp::CheckTautology(vectLit)) {
                        ++uOrigClaSize;
                        break;
                    }
                    for(size_t uCol=0;uCol<vectLit.size();++uCol)
                    {
                        *FileOp::ofJudgeFileResult << vectLit[uCol];
                    }
                    *FileOp::ofJudgeFileResult << endl;
                    continue;
                }
                char ch = strClause[i];
                if (ch >= 'A' && ch <= 'Z' && ch != 'X')
                    strLit += ('x' + InitFunction::to_String(ch - 'A' + 1));
                else {
                    switch (ch) {
                        case 'p':ch = 'P';
                            break;
                        case 'X':ch = 'x';
                            break;
                        case 'c':ch = 'a';
                            break;
                        case '=':
                            if (isEqnLit)
                                return READERR;
                            ch = ',';
                            strLit = "E(" + strLit;
                            isEqnLit = true;
                            break;
                        case '!':
                            if (strClause[++i] == '=') {
                                ch = ',';
                                strLit = "~E(" + strLit;
                                isEqnLit = true;
                            }
                            break;
                        default:
                            break;
                    }
                    strLit += ch;
                }
                if (strClause[i] == '=') {
                    while (strClause[++i] == ' ') {
                    }
                    if (strClause[i] >= '0' && strClause[i] <= '9') {
                        strLit += "a" + InitFunction::to_String(200 + strClause[i] - '0' + 1);
                    } else
                        --i;
                }
            }
        }
    }
    StrategyFunction::O_ClauseNum = uOrigClaSize - 1;
    for (size_t eLitInd = 0; eLitInd < vEqn.size(); ++eLitInd) {
        vector<string>&vectLit = vEqn[eLitInd];
        for (size_t uCol = 0; uCol < vectLit.size(); ++uCol)
        {
            *FileOp::ofJudgeFileResult << vectLit[uCol];
        }
        *FileOp::ofJudgeFileResult << endl;
    }
    FileOp::ofJudgeFileResult->close();
    return READOK;
}
