/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef HASHNODE_H
#define HASHNODE_H
#include "globalFunc.h"
#include "Term.h"
#include "dataTypeDef.h"
#include "HashNode.h"
class HashNode {
public:
    long uHashCode; 
    Term* termPtr; 
    HashNode* pNext;
    UINT32 times;
    HashNode(long _uHashCode, Term*_term) :uHashCode(_uHashCode), termPtr(_term), pNext(nullptr), times(1){};
    HashNode();
    HashNode(const HashNode& orig);
    virtual ~HashNode();
    inline bool operator<(const HashNode&hashNode) const {
        return uHashCode < hashNode.uHashCode;
    }

    inline bool operator>(const HashNode&hashNode) const {
        return uHashCode > hashNode.uHashCode;
    }

    inline bool operator==(const HashNode&hashNode) const {
        return uHashCode == hashNode.uHashCode;
    }
private:

};
class HashNodeCmpByCode :greater<HashNode*> {
public:
    bool operator()(HashNode* h1, HashNode* h2) const{ return h1->uHashCode<h2->uHashCode; }
};


#endif /* HASHNODE_H */

