/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef LITERAL_H
#define LITERAL_H
#include "Term.h"
#include "globalFunc.h"
class Clause;
class Literal {
public:
    Term* subTerm; 
    UINT32 uLitCode; 
    Clause* claPtr;
    Literal* parentLitPtr; 
    UINT32 uActive, uPassive;
    UINT8 isDel; //1 del 0-no
    bool isDrop;
    UINT32 sDuct;
    bool pureLit;
    UINT8 goalDeepth;
    UINT32 countPred;
    UINT32 countPairPred;
    UINT8 litAttr; 
    UINT16 termCount12;
    UINT16 termCount11;
    UINT16 termCount21;
    Literal(Term* _subT, UINT32 _uLitCode, Clause* _claPtr, Literal* _parentLitPtr)
    : subTerm(_subT), uLitCode(_uLitCode), claPtr(_claPtr), parentLitPtr(_parentLitPtr), uActive(0), uPassive(0), isDel(0), isDrop(false),sDuct(0),pureLit(false),goalDeepth(10),countPred(0),countPairPred(0)
    ,litAttr(0),termCount12(0),termCount11(0),termCount21(0){
    };

    Literal() : subTerm(nullptr), uLitCode(0), claPtr(nullptr), parentLitPtr(nullptr), uActive(0), uPassive(0), isDel(0) , isDrop(false),sDuct(0),pureLit(false),goalDeepth(10),countPred(0),countPairPred(0)
    ,litAttr(0),termCount12(0),termCount11(0),termCount21(0){
    };

    Literal(UINT32 row, UINT16 col) {
    };
    
    ~Literal(void) {
        claPtr = nullptr;
    };
    Literal(const Literal& orig);
    void exEqnTerm();
    
    inline bool coypLit(Literal* lit){
        Literal* newLit = new Literal();
        newLit->claPtr = lit->claPtr;
        newLit->subTerm = lit->subTerm;
    }
    inline bool isConLit(){
        if(subTerm->uVarCount ==0)
            return true;
        else
            return false;
    }
    inline bool isSingleVarliteral(){
        return subTerm->IsSingleVarLit();
    }
    inline bool isShareVarLiteral(){
        return subTerm->IsShareVarLit();
    }
    inline bool noExistShareVar(){
        return !(subTerm->IsShareVarLit());
    }
    inline bool isComEq(){
         if(subTerm->isPosEqnTerm() && subTerm->subTermPtr[0]->isVar() && subTerm->subTermPtr[1]->isVar() && subTerm->subTermPtr[0]->EqualInSameCla(subTerm->subTermPtr[1]))
             return true;
         else
             return false;
    }
    inline float SteadyValue() {
        return subTerm->fSteadyValue;
    }
    inline float RelationValue() {
        return subTerm->RelationValue();
    }
    inline UINT32 Col()const {
        return GetVarId(uLitCode);
    }
    inline UINT32 Row() const {
        return GetClaId(uLitCode);
    }
    inline UINT32 ParentLitCode() {
        if (parentLitPtr) return parentLitPtr->uLitCode;
        return uLitCode;
    }
    inline UINT32 ParentLitRow() {
        if (parentLitPtr) return parentLitPtr->Row();
        return Row();
    }
    inline UINT16 ParentLitCol() {
        if (parentLitPtr) return parentLitPtr->Col();
        return Col();
    }
    inline void ReCol(UINT16 uNewCol) {
        uLitCode = uLitCode&~0xFF | uNewCol;
    }
    inline int IsNeLit(){
        UINT32 uPredProp = GetCodeProp(subTerm->iTermCode);
        if((uPredProp== TNegPred) ||(uPredProp== TNegEqn))
            return 0;
        else
            return 1;
    }
    inline bool isPairPred(const Literal* lit) {
        INT32 iTermCodeA = subTerm->iTermCode;
        INT32 iTermCodeB = lit->subTerm->iTermCode;
        if (TPairPred == GetCodeProp(iTermCodeA) + GetCodeProp(iTermCodeB)
                && GetCodeId(iTermCodeA) == GetCodeId(iTermCodeB))
            return true;
        return false;
    }
    inline bool isEqPred(const Literal* lit) {
        INT32 iTermCodeA = subTerm->iTermCode;
        INT32 iTermCodeB = lit->subTerm->iTermCode;
        return iTermCodeA==iTermCodeB;
    }
    UINT32 pairLitSize();
    void AddPredLst();
    vector<Literal*>* getPredLst();
    vector<Literal*>* getPairPredLst();
    void DelPred();
    static void delIndex();
    bool isOnlyOneAppeared();
private:

};

#endif /* LITERAL_H */

