/*
*  Copyright 2022 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include "FileOp.h"
#include "dataTypeDef.h"
#include "globalFunc.h"
#include "StrategyParam.h"
#include "SocketOp.h"
FileOp::FileOp() {
}

FileOp::FileOp(const FileOp& orig) {
}

FileOp::~FileOp() {
}
string FileOp::homePath;
string FileOp::strategyFile;
int FileOp::strategyFileSize = 0;
int FileOp::strategyMode;
int FileOp::runMode;
UINT32 FileOp::runFileId = 0;
UINT32 FileOp::outPutRCount = 0;
string FileOp::judgeOriginalFileFullName;
string FileOp::judgeOriginalFileName;
string FileOp::JudgeFileFullName; 
string FileOp::JudgeFileName;
string FileOp::JudgeFileFullNameNoExt; 
string FileOp::JudgeFileDir;	
string FileOp::JudgeFileResult;
FILETYPE FileOp::fileType = MYDefine;
ofstream *FileOp::ofJudgeFileResult;
ofstream *FileOp::ofJudgeAllFileResult;
ofstream *FileOp::ofSingleEndUnitCla = NULL;
ofstream *FileOp::ofNouseCla = NULL;
vector<string> FileOp::StrategyfileName;
vector<string> FileOp::StrategyCorrespondingFilePath;
string FileOp::g_FileDir = "";	  
string FileOp::g_WorkDir = "";	
string FileOp::g_PreFileFullName = ""; 
string FileOp::g_OutputPath = "";
string FileOp::appPath = "";
string FileOp::workSpace = "";
ofstream* FileOp::ofRealInfoOut = NULL;	
ofstream* FileOp::ofLogOut = NULL;		
ofstream* FileOp::ofPathOut = NULL;
ofstream* FileOp::ofOutput = nullptr;
ofstream* FileOp::ofProofComp = nullptr;
ofstream* FileOp::strategyRecord = nullptr;
INT32 FileOp::runFileNum = 0;

void FileOp::getTopPath(bool useVersion){
    if(useVersion){
        char* path;
        path = getenv("HOME");
        string pathGet(path);
        homePath = pathGet;
        strategyFile= appPath + "/strategy";
    }
    else {
        char* path;
        path = getenv("HOME");
        string pathGet(path);
        homePath = pathGet;
        strategyFile= homePath + "/Desktop/strategy";
    }
}

RESULT FileOp::AnalysisFileName(string FilePath)
{
    size_t pos = FilePath.find_last_of('/');
    if (pos == -1)
        return READERR;
    else {
        JudgeFileFullName = FilePath;
        JudgeFileDir = FilePath.substr(0, pos);
        JudgeFileName = FilePath.substr(pos + 1);
        size_t posEnd = JudgeFileName.find_last_of('.');
        JudgeFileFullNameNoExt = JudgeFileName.substr(0, posEnd); 
        string suffix=JudgeFileName.substr(posEnd+1);
        if (suffix == "tptp" || suffix == "TPTP") {
            fileType = TPTP;
        } else if (suffix == "fof" || suffix == "FOF") {
            fileType = FOF;
        } else {
            fileType = MYDefine;
        }
        JudgeFileResult =homePath + "/Desktop/output";
        if(StrategyParam::orForCompition)
            JudgeFileResult = FileOp::workSpace;
        g_WorkDir =homePath + "/Desktop/output";
         if(StrategyParam::orForCompition)
            g_WorkDir = FileOp::workSpace;
        g_OutputPath = g_WorkDir + "/" + JudgeFileFullNameNoExt;
        g_PreFileFullName = g_WorkDir + "/" + JudgeFileFullNameNoExt + ".pre";
        if (!isExistDir(g_OutputPath))
            return ERR_OUTFOLDER;
        if (!CreateLogFile())
            return ERR_OUTFOLDER;
        if(StrategyParam::orForCompition)
            CreateTotalOutputFile(false);
        return READOK;
    }
}

void FileOp::CreateResultFile()
{
    string strLogPath = FileOp::JudgeFileResult+ "/" + FileOp::JudgeFileFullNameNoExt + ".log";
    try {
        ofJudgeFileResult = new ofstream(strLogPath.c_str(),ios::out);
        return;
    } catch (exception* e) {
        cout << "运行信息输出错误" << e->what()<< endl;
    }
}

bool FileOp::CreateRunInfoFile(UINT32 StartId )
{
    string runId = to_string(StartId);
    if(runId.length() == 1){
        runId = "000" + runId;
    }
    else if(runId.length() == 2){
        runId = "00" + runId;
    }
    else if(runId.length() == 3){
        runId = "0" + runId;
    }
    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.run";
    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.path";  
    try {
        if(ofRealInfoOut){
            if(ofRealInfoOut->is_open()) {
                ofRealInfoOut->close();
                ofRealInfoOut = nullptr; 
            }
        }
        if(ofPathOut) {
            if (ofPathOut->is_open()) {
                ofPathOut->close();
                ofPathOut = nullptr;
            }
        }
        ofRealInfoOut = new ofstream(strOutRunPath, ios::app);
        ofPathOut = new ofstream(strPath, ios::app);
        return true;
    } catch (exception* e) {
        return false;
    }
}
bool FileOp::delCreateRunInfoFile(UINT32 StartId )
{
    string runId = to_string(StartId);
    if(runId.length() == 1){
        runId = "000" + runId;
    }
    else if(runId.length() == 2){
        runId = "00" + runId;
    }
    else if(runId.length() == 3){
        runId = "0" + runId;
    }
    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.run";
    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + runId + "_P1.path";  
    try {
        FILE* fp;
        char ch;
        if((fp = fopen(strOutRunPath.c_str(),"r")) != NULL){
            fseek(fp,0,SEEK_SET);
            ch = fgetc(fp);
            if(ch == EOF){
                fclose(fp);
                remove(strOutRunPath.c_str());
            }
            else
                fclose(fp);
        }
        if((fp = fopen(strPath.c_str(),"r")) != NULL){
            fseek(fp,0,SEEK_SET);
            ch = fgetc(fp);
            if(ch == EOF){
                fclose(fp);
                remove(strPath.c_str());
            }
            else
                fclose(fp);
        }
        return true;
    } catch (exception* e) {
        return false;
    }
}

bool FileOp::CreateRunInfoFilePre(UINT32 StartId )
{
    string strOutRunPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + to_string(StartId) + "_Pre.run";
    string strPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + "_C" + to_string(StartId) + "_Pre.path";  
    try {
        ofRealInfoOut = new ofstream(strOutRunPath, ios::app);
        ofPathOut = new ofstream(strPath, ios::app);
        return true;
    } catch (exception* e) {
        return false;
    }
}

bool FileOp::CreateLogFile()
{
    string strLogPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".log";
    string strLog = homePath + "/Desktop/proofRes.txt";
    if(StrategyParam::orForCompition)
        strLog = FileOp::appPath + "/proofRes.txt";
    try {
        ofLogOut = new ofstream(strLogPath, ios::out);
        ofJudgeAllFileResult = new ofstream(strLog.c_str(),ios::app);
        return true;
    } catch (exception* e) {
        return false;
    }
}


bool FileOp::CreateTotalOutputFile(bool parseTime)
{
    if(parseTime){
        JudgeFileResult = FileOp::workSpace;
        g_OutputPath = FileOp::workSpace;
    }
    string strOutput = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".out";
    try {
        ofOutput = new ofstream(strOutput, ios::out);
        return true;
    } catch (exception* e) {
        return false;
    }
}


string FileOp::getFilePath(string &fileFullName)
{
    size_t pos = fileFullName.find_last_of('/');
    if (pos == -1)
        return fileFullName;
    return fileFullName.substr(0, pos);
}

string FileOp::getFileName(string &fileFullName)
{
    size_t pos = fileFullName.find_last_of('/');
    if (pos == -1)
        return fileFullName;
    return fileFullName.substr(pos + 1);
}

string FileOp::getFileNameNoExt(string fileFullName)
{
    size_t posBeg = fileFullName.find_last_of('/');
    size_t posEnd = fileFullName.find_last_of('.');
    if (posEnd == -1)
        return fileFullName.substr(posBeg + 1);
    return fileFullName.substr(posBeg + 1, posEnd - posBeg);
}

void FileOp::outReleaseOf(){
    if (ofRealInfoOut) {
        ofRealInfoOut->close();
        ofRealInfoOut = NULL;
    }
    if (ofPathOut) {
        ofPathOut->close();
        ofPathOut = NULL;
    }
}

void FileOp::ReleaseOf()
{
    if (ofRealInfoOut) {
        ofRealInfoOut->close();
        ofRealInfoOut = NULL;
    }
    if (ofLogOut) {
        ofLogOut->close();
        ofLogOut = NULL;
    }
    if (ofPathOut) {
        ofPathOut->close();
        ofPathOut = NULL;
    }
    if (ofJudgeAllFileResult) {
        ofJudgeAllFileResult->close();
        ofJudgeAllFileResult = NULL;
    }
    if (StrategyParam::orForCompition) {
        if (ofOutput) {
            ofOutput->close();
            ofOutput = NULL;
        }
        if (ofProofComp) {
            ofProofComp->close();
            ofProofComp = NULL;
        }
    }
    FileOp::StrategyfileName.clear();
    vector<string>().swap(FileOp::StrategyfileName);
}

void FileOp::PrintINFOEndRSinglePre(string& msg) {
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".res";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::prinfResForE(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".res";
    ofstream ofInfoStream(strInfoPath, ios::app);
    ofInfoStream << msg << endl;
    ofInfoStream.close(); 
}

void FileOp::prinfPreResForE(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".res";
    ofstream ofInfoStream(strInfoPath, ios::app);
    ofInfoStream << msg;
    ofInfoStream.close(); 
}

void FileOp::PrintINFOEndRSinglePreNoUse(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".nouse";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFONoUsePre(string& msg)
{   
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".nousepre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

RESULT FileOp::FilePathAnaysis(const string& fileFullName)
{
    
}

bool FileOp::isExistDir(string strDir)
{
    DIR *mydir = NULL;
    if((mydir = opendir(strDir.c_str()))==NULL)
    {
        int ret = mkdir(strDir.c_str(),0777);
        if(ret != 0)
        {
            cout<<"mkdir fail\n";
            return false;
        }
        else
            return true;
    }
    else{
        closedir(mydir);
        return true;
    }
}

bool FileOp::isExistProof(string strDir)
{
    struct dirent* ptr;
    DIR* dir = opendir(g_OutputPath.c_str());
    if(dir == nullptr){
        return false;
    }
    rewinddir(dir);
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        string fileName = g_OutputPath + "/" + name;
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if (suffix == "path" || suffix == "run") {
            name = "";
            fileName = "";
            closedir(dir);
            return true;
        }        
        name = "";
        fileName = "";
    }
    closedir(dir);
    return false;
}

void FileOp::LogOut(const string& msg)
{
    if (!ofLogOut)
        CreateLogFile();
    try {
        *ofLogOut << msg << endl;
    } catch (exception* e) {
        string errInfo = e->what();
        *ofLogOut << errInfo << endl;
    }
}

void FileOp::PrintINFO(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".info";
    ofstream ofInfoStream(strInfoPath, ios::app);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORPre(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".rpre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORPreAfter(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".rapre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORSinglePre(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".rspre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}

void FileOp::PrintINFORSinglePreAfter(string& msg)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".raspre";
    ofstream ofInfoStream(strInfoPath, ios::out);
    ofInfoStream << msg << endl;
    ofInfoStream.close();
}
void FileOp::WritePreFile(const string& str)
{
    ofstream ofInfoStream(g_PreFileFullName, ios::out);
    ofInfoStream << str << endl;
    ofInfoStream.close();
}

void FileOp::RInvaildInfoOut(string& rundMsg, INT32 StartId)
{
    try {
        if (!ofRealInfoOut)
            CreateRunInfoFile(StartId);
        *ofRealInfoOut << rundMsg << endl;
        *ofPathOut << rundMsg << endl;
        ofRealInfoOut->flush();
    } catch (exception* e) {
        *ofRealInfoOut << "R冗余信息输出错误！" << e->what() << endl;
    }
}

void FileOp::RInvaildInfoOutPath(string& rundMsg, INT32 StartId)
{
    try {
        if (!ofPathOut)
            CreateRunInfoFile(StartId);
        *ofPathOut << rundMsg << endl;
        ofPathOut->flush();
    } catch (exception* e) {
        *ofPathOut << "R冗余信息输出错误！" << e->what() << endl;
    }
}

void FileOp::RunInfoOut(vector<Literal*>& vOptTri, Clause* newCla, INT32 StartId, vector<string>* strOptTris)
{
	try {
        if (!ofRealInfoOut)
            CreateRunInfoFile(StartId);
        string strTmpMsg_P;
        vector<Literal*>::iterator vLitIt;
        for (vLitIt = vOptTri.begin(); vLitIt < vOptTri.end(); ++vLitIt) {
            if (strOptTris) {
                strOptTris->push_back("[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString());
                strTmpMsg_P += strOptTris->back() + "\n";
                *ofPathOut << "[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
                ++vLitIt;
                strOptTris->push_back("[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString());
                strTmpMsg_P += strOptTris->back() + "\n";
                *ofPathOut << "[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";

            } else {
                strTmpMsg_P += "[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString() + "\n";
                *ofPathOut << "[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";

                ++vLitIt;
                strTmpMsg_P += "[C" + to_string((*vLitIt)->Row()) + "_" + to_string((*vLitIt)->Col()) + "]" + (*vLitIt)->subTerm->ToString() + "\n";
                *ofPathOut << "[C" << (*vLitIt)->Row() << "_" << to_string((*vLitIt)->Col()) << "]-";
            }
        }
        if (newCla) {
            strTmpMsg_P += "R[" + to_string(newCla->uClaId) + "]:";
            for (UINT16 i = 0; i < newCla->uLitNum; ++i) {
                Literal*lit = newCla->LitPtr[i];
                strTmpMsg_P += "[" + to_string(lit->ParentLitRow()) + "_" + to_string(lit->ParentLitCol()) + "]" + lit->subTerm->ToString() + "+";
            }
            string strPrint = strTmpMsg_P.erase(strTmpMsg_P.size() - 1);
            *ofRealInfoOut << strPrint;
        } else {
            strTmpMsg_P += "R:空子句";
            *ofRealInfoOut << strTmpMsg_P << endl;
            ofRealInfoOut->flush();
        }
    } catch (exception* e) {
        *ofRealInfoOut << "运行信息输出错误" << e->what() << endl;
    }
}

void FileOp::WriteTriPath(string& str) {
    if (!ofRealInfoOut) {
        assert(ofRealInfoOut);
        cout << "运行信息输出错误未创建" << endl;
    }
    try {
        *ofRealInfoOut << str << endl;
    } catch (exception* e) {
        cout << "运行信息输出错误" << e->what() << endl;
    }
}

void FileOp::WriteR(Clause* newCla) {
    ++FileOp::outPutRCount;
    if(FileOp::outPutRCount > 100){
        ++FileOp::runFileId;
        FileOp::outPutRCount = 0;
    }
    if (newCla) {
        string strPrint = "R[" + to_string(newCla->uClaId) + "]:";
        for (UINT16 i = 0; i < newCla->uLitNum; ++i){
            Literal*lit = newCla->LitPtr[i];
            strPrint += "[" + to_string(lit->ParentLitRow()) + "_" + to_string(lit->ParentLitCol()) + "]" + lit->subTerm->ToString() + "+";
        }
        strPrint = strPrint.erase(strPrint.size() - 1);
        *ofRealInfoOut << strPrint;
    } else {
        *ofRealInfoOut << "R:空子句" << endl;
    }
    ofRealInfoOut->flush();
}

void FileOp::OperDir(string src,vector<string>* fileName)
{
    DIR* dir;
    struct dirent* ptr;
    UINT16 i=0;
    dir = opendir(src.c_str());
    if(dir == nullptr){
        return;
    }
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if (suffix == "tptp" || suffix == "TPTP" || suffix == "txt"|| suffix == "p"|| suffix == "P") {
            fileName->push_back(name);
            if (++i >= 30000)
                break;
        }
    }
    closedir(dir);
}

void FileOp::delRes(){
    struct dirent* ptr;
    DIR* dir = opendir(g_OutputPath.c_str());
    if(dir == nullptr){
        return;
    }
    rewinddir(dir);
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);      
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);       
        if (suffix == "path" || suffix == "run") {
            size_t signStart = name.find_last_of("_");
            string preGenStr = name.substr(signStart+1,posEnd);
            if(preGenStr != "Pre"){
                string fileName = g_OutputPath + "/" + name;
                remove(fileName.c_str());
            }
        }
        name = "";
    }
    closedir(dir);    
}

void FileOp::delRunFiles(){
    struct dirent* ptr;
    DIR* dir = opendir(g_OutputPath.c_str());
    if(dir == nullptr){
        return;
    }
    rewinddir(dir);
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        string fileName = g_OutputPath + "/" + name;
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if (suffix == "path" || suffix == "run") {
            remove(fileName.c_str());
            name = "";
            fileName = "";
            continue;
        }        
        name = "";
        fileName = "";
    }
    closedir(dir);
}

void FileOp::delAllFiles(){
    struct dirent* ptr;
    DIR* dir = opendir(g_OutputPath.c_str());
    if(dir == nullptr){
        return;
    }
    rewinddir(dir);
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        string fileName = g_OutputPath + "/" + name;
        if(StrategyParam::preprocess) {
            size_t posEnd = name.find_last_of(".");
            string suffix = name.substr(posEnd + 1);
            if (suffix == "info" || suffix == "res" || suffix == "log") {
                name = "";
                fileName = "";
                continue;
            }
        }
        else if(StrategyParam::useCombinedSys != 0) {
            size_t posEnd = name.find_last_of(".");
            string suffix = name.substr(posEnd + 1);
             if (suffix == "info" || suffix == "res" || suffix == "run"){
                 name = "";
                fileName = "";
                 continue;
             }
        }
        remove(fileName.c_str());
        name = "";
        fileName = "";
    }
    closedir(dir);
}

void FileOp::delAllFilesComplete(string filePath){
    struct dirent* ptr;
    DIR*  dir = opendir(filePath.c_str());
    if(dir == nullptr){
        return;
    }
    rewinddir(dir);
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        string fileName = filePath + "/" + name;
        remove(fileName.c_str());
        name = "";
        fileName = "";
    }
    closedir(dir);
}

bool FileOp::isFileEmpty(string filePath){
    FILE* fp;
    fp = fopen(filePath.c_str(),"r");
    if(!fp){
        return false;
    }
    char ch=fgetc(fp);
    if(ch==EOF){
        fclose(fp);
        return true;
    }
    else{
        fclose(fp);
        return false;
    }
}

void FileOp::readCorrespondingStrategy(string src,vector<string>* fileName)
{
    DIR* dir;
    struct dirent* ptr;
    dir = opendir(src.c_str());
    if(dir == nullptr){
        return;
    }
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if ((name.find("strategy") != string::npos) && (suffix == "txt")) {
            fileName->push_back(src + "/" + name);
        }
    }
    closedir(dir);
}

void FileOp::packageCorrespondingStrategyAndSaveBinary(string src, vector<string>* fileName){
    int len = 0;
    ofstream outFile(src.c_str(),ios::app);
    for(len = 0; len < FileOp::StrategyCorrespondingFilePath.size(); ++len){
        if(1){
            string str;
            ifstream openFile(FileOp::StrategyCorrespondingFilePath[len]);
            if(openFile.fail()){
                cout<< "open file failed"<< endl;
                continue;
            }
            int firstPos = FileOp::StrategyCorrespondingFilePath[len].find_last_of("/")+1;
            string fileName = FileOp::StrategyCorrespondingFilePath[len].substr(firstPos);
            int secondPos = fileName.find_first_of("_")+1;
            fileName = fileName.substr(secondPos);
            outFile << fileName << endl;
            while(getline(openFile,str)){
                outFile << str << endl; 
            }
            openFile.close();
        }
    }
    outFile.close();
    FileOp::StrategyCorrespondingFilePath.clear();
    vector<string>().swap(FileOp::StrategyCorrespondingFilePath);
}

void FileOp::packageCorrespondingStrategyAndCheck(string src){
    string lineContent;
    string outputFileName;
    bool flag = false;
    ifstream inFile(src.c_str());
    if(inFile.fail()){
        cout<< "open file failed"<< endl;
        return;
    }
    while(getline(inFile,lineContent)){
        if(lineContent.find(".txt") != string::npos){
            outputFileName = "/home/ars01/Desktop/optimaizePathStrategies1/" +lineContent;  
            flag = true;
        }
        if(flag) {
            ofstream outFile(outputFileName, ios::app);
            outFile << lineContent << endl;
            if (lineContent.find("锁子句约简模式") != string::npos) {
                outFile.close();
                flag = false;
            }
        }
        
    }
    inFile.close();
}

bool FileOp::findPackageCorrespondingStrategy(string src, string searchCorrespondingStrategies){   
    string lineContent;
    ifstream inFile(src.c_str());
    if(inFile.fail()){
        cout<< "open file failed"<< endl;
        return false;
    }
    while(getline(inFile,lineContent)){
        if(lineContent.find(".txt") != string::npos){
            int endPos = lineContent.find_last_of("."); 
            string fileName = lineContent.substr(0, endPos);
            if(fileName == searchCorrespondingStrategies){
                inFile.close();
                return true;
            }
        }
    }
    inFile.close();
    return false;
    
}

void FileOp::findCorrespondingStrategy(string src, string searchCorrespondingStrategies){
    bool flag = false;
    string lineContent;
    ifstream inFile(src.c_str());
    if(inFile.fail()){
        cout<< "open file failed"<< endl;
        return;
    }
    while(getline(inFile,lineContent)){
        if(lineContent.find(".txt") != string::npos){
            int endPos = lineContent.find_last_of("."); 
            string fileName = lineContent.substr(0, endPos);
            if(fileName == searchCorrespondingStrategies){
                flag = true;
            } 
        }
        if(flag){
            setSingleCorrespondingStrategy(lineContent);
        }
        if((lineContent.find("锁子句约简模式") != string::npos) && flag){
            break;
        }
    }
    inFile.close();
}

void FileOp::setSingleCorrespondingStrategy(string str){
    int i=0;
    for(i=0;i<1;i++)
    {
        if (str.find("单元子句选取策略0") != string::npos){
            StrategyParam::unitChoose = 0;
            continue;
        }
        else if (str.find("单元子句选取策略1") != string::npos){
            StrategyParam::unitChoose = 1;
            continue;
        }
        else if (str.find("单元子句选取策略2") != string::npos){
            StrategyParam::unitChoose = 2;
            continue;
        }
        else if (str.find("单元子句选取策略3") != string::npos){
            StrategyParam::unitChoose = 3;
            continue;
        }
        else if (str.find("单元子句选取策略4") != string::npos){
            StrategyParam::unitChoose = 4;
            continue;
        }
        if (str.find("单元子句归结次数策略0") != string::npos){
            StrategyParam::unitDeduct = 0;
            continue;
        }
        else if (str.find("单元子句归结次数策略1") != string::npos){
            StrategyParam::unitDeduct = 1;
            continue;
        }
        else if (str.find("单元子句归结次数策略2") != string::npos){
            StrategyParam::unitDeduct = 2;
            continue;
        }
        if (str.find("单元子句冗余次数策略0") != string::npos){
            StrategyParam::unitRedunt = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数策略1") != string::npos){
            StrategyParam::unitRedunt = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数策略2") != string::npos){
            StrategyParam::unitRedunt = 2;
            continue;
        }
        if (str.find("单元子句稳定度策略0") != string::npos){
            StrategyParam::unitSteady = 0;
            continue;
        }
        else if (str.find("单元子句稳定度策略1") != string::npos){
            StrategyParam::unitSteady = 1;
            continue;
        }
        else if (str.find("单元子句稳定度策略2") != string::npos){
            StrategyParam::unitSteady = 2;
            continue;
        }
        if (str.find("单元子句函数嵌套层策略0") != string::npos){
            StrategyParam::unitFuncLayer = 0;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略1") != string::npos){
            StrategyParam::unitFuncLayer = 1;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略2") != string::npos){
            StrategyParam::unitFuncLayer = 2;
            continue;
        }
        if (str.find("候选子句选取策略0") != string::npos){
            StrategyParam::candChoose = 0;
            continue;
        }
        else if (str.find("候选子句选取策略1") != string::npos){
            StrategyParam::candChoose = 1;
            continue;
        }
        else if (str.find("候选子句选取策略2") != string::npos){
            StrategyParam::candChoose = 2;
            continue;
        }
        else if (str.find("候选子句选取策略3") != string::npos){
            StrategyParam::candChoose = 3;
            continue;
        }
        else if (str.find("候选子句选取策略4") != string::npos){
            StrategyParam::candChoose = 4;
            continue;
        }
        if (str.find("候选子句归结次数策略0") != string::npos){
            StrategyParam::candDeduct = 0;
            continue;
        }
        else if (str.find("候选子句归结次数策略1") != string::npos){
            StrategyParam::candDeduct = 1;
            continue;
        }
        else if (str.find("候选子句归结次数策略2") != string::npos){
            StrategyParam::candDeduct = 2;
            continue;
        }
         if (str.find("候选子句冗余次数策略0") != string::npos){
            StrategyParam::candRedunt = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数策略1") != string::npos){
            StrategyParam::candRedunt = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数策略2") != string::npos){
            StrategyParam::candRedunt = 2;
            continue;
        }
         if (str.find("候选子句文字数策略0") != string::npos){
            StrategyParam::candClause = 0;
            continue;
        }
        else if (str.find("候选子句文字数策略1") != string::npos){
            StrategyParam::candClause = 1;
            continue;
        }
        else if (str.find("候选子句文字数策略2") != string::npos){
            StrategyParam::candClause = 2;
            continue;
        }
       if (str.find("候选子句稳定度策略0") != string::npos){
            StrategyParam::candSteady = 0;
            continue;
        }
        else if (str.find("候选子句稳定度策略1") != string::npos){
            StrategyParam::candSteady = 1;
            continue;
        }
        else if (str.find("候选子句稳定度策略2") != string::npos){
            StrategyParam::candSteady = 2;
            continue;
        }
         if (str.find("单元子句归结次数最大值策略") != string::npos){           
            StrategyParam::unitDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("单元子句归结次数更新策略0") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略1") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略2") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略3") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略4") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 4;
            continue;
        }
        if (str.find("单元子句冗余次数最大值策略") != string::npos){
            StrategyParam::unitReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
         if (str.find("单元子句冗余次数更新策略0") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略1") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略2") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略3") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略4") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 4;
            continue;
        }
        if (str.find("候选子句归结次数最大值策略") != string::npos){
            StrategyParam::candDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("候选子句归结次数更新策略0") != string::npos){
            StrategyParam::candDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略1") != string::npos){
            StrategyParam::candDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略2") != string::npos){
            StrategyParam::candDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略3") != string::npos){
            StrategyParam::candDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略4") != string::npos){
            StrategyParam::candDeductTimesUpdate = 4;
            continue;
        }
       if (str.find("候选子句冗余次数最大值策略") != string::npos){
            StrategyParam::candReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("候选子句冗余次数更新策略0") != string::npos){
            StrategyParam::candReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略1") != string::npos){
            StrategyParam::candReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略2") != string::npos){
            StrategyParam::candReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略3") != string::npos){
            StrategyParam::candReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略") != string::npos){
            StrategyParam::candReduntTimesUpdate = 4;
            continue;
        }
        if (str.find("候选子句文字策略0") != string::npos){
            StrategyParam::candLiteral = 0;
            continue;
        }
        else if (str.find("候选子句文字策略1") != string::npos){
            StrategyParam::candLiteral = 1;
            continue;
        }
        else if (str.find("候选子句文字策略2") != string::npos){
            StrategyParam::candLiteral = 2;
            continue;
        }
        if (str.find("候选子句文字归结次数策略0") != string::npos){
            StrategyParam::candLiteralDeductTimes = 0;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略1") != string::npos){
            StrategyParam::candLiteralDeductTimes = 1;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略2") != string::npos){
            StrategyParam::candLiteralDeductTimes = 2;
            continue;
        }
        if (str.find("候选子句文字稳定度策略0") != string::npos){
            StrategyParam::candLiteralSteady = 0;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略1") != string::npos){
            StrategyParam::candLiteralSteady = 1;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略2") != string::npos){
            StrategyParam::candLiteralSteady = 2;
            continue;
        }
        if ((str.find("R权重赋值策略0:") != string::npos)){
            StrategyParam::useRandrom = true;
            continue;
        }
        else if(str.find("R权重赋值策略1:") != string::npos)
        {
            StrategyParam::useRandrom = false;
            continue;
        }
        if ((str.find("不允许小于原始子句文字最大数:") != string::npos)){
            StrategyParam::Rsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句文字最大数:") != string::npos)
        {
            StrategyParam::Rsmall = true;
            continue;
        }
         if ((str.find("不允许小于原始子句层数最大数:") != string::npos)){
            StrategyParam::RFsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句层数最大数:") != string::npos)
        {
            StrategyParam::RFsmall = true;
            continue;
        }
        if ((str.find("不允许R因子归结:") != string::npos)){
            StrategyParam::RRes = false;
            continue;
        }
        else if(str.find("允许R因子归结:") != string::npos)
        {
            StrategyParam::RRes = true;
            continue;
        }
        if (str.find("R文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_NUM = stoi(str.substr(str.find_first_of(":") + 1));
            if ((StrategyParam::R_MAX_NUM < StrategyParam::R_INIT_MAX_NUM) && !StrategyParam::Rsmall) {
                StrategyParam::R_MAX_NUM = StrategyParam::R_INIT_MAX_NUM;
                StrategyParam::R_MAX_NUM_TMP = StrategyParam::R_INIT_MAX_NUM;
            }
            continue;
        }
        if (str.find("R函数嵌套层") != string::npos){
            StrategyParam::R_MAX_FUNCLAYER = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_FUNCLAYER_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            if ((StrategyParam::R_MAX_FUNCLAYER < StrategyParam::R_INIT_MAX_FUNCLAYER) && !StrategyParam::RFsmall) {
                StrategyParam::R_MAX_FUNCLAYER = StrategyParam::R_INIT_MAX_FUNCLAYER* 2+1;
                StrategyParam::R_MAX_FUNCLAYER_TMP = StrategyParam::R_INIT_MAX_FUNCLAYER* 2+1;
            }
            continue;
        }
        if (str.find("R权重大小") != string::npos){
            StrategyParam::R_Weight = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("R2文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_NOPAIR = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("R文字冗余策略0") != string::npos){
            StrategyParam::litRundent = 1;
            continue;
        }
        else if(str.find("R文字冗余策略1") != string::npos)
        {
            StrategyParam::litRundent = 0;
            continue;
        }
        
        if (str.find("中间归结式生成策略0") != string::npos){
            StrategyParam::midR = 0;
            continue;
        }
        else if(str.find("中间归结式生成策略1") != string::npos)
        {
            StrategyParam::midR = 1;
            continue;
        }
        else if(str.find("中间归结式生成策略2") != string::npos)
        {
            StrategyParam::midR = 2;
            continue;
        }
        else if(str.find("中间归结式生成策略3") != string::npos)
        {
            StrategyParam::midR = 3;
            continue;
        }
        else if(str.find("中间归结式生成策略4") != string::npos)
        {
            StrategyParam::midR = 4;
            continue;
        }
        else if(str.find("中间归结式生成策略5") != string::npos)
        {
            StrategyParam::midR = 5;
            continue;
        }
        else if(str.find("中间归结式生成策略6") != string::npos)
        {
            StrategyParam::midR = 6;
            continue;
        }
        else if(str.find("中间归结式生成策略7") != string::npos)
        {
            StrategyParam::midR = 1000;
            continue;
        }
         if (str.find("项重写策略0") != string::npos){
            StrategyParam::termRewriting = 0;
            continue;
        }
        else if (str.find("项重写策略1") != string::npos){
            StrategyParam::termRewriting = 1;
            continue;
        }
        else if (str.find("项重写策略2") != string::npos){
            StrategyParam::termRewriting = 2;
            continue;
        }
         if (str.find("替换项的大小策略0") != string::npos){
            StrategyParam::termRewritingSize  = 1;
            continue;
        }
        else if (str.find("替换项的大小策略1") != string::npos){
            StrategyParam::termRewritingSize  = 2;
            continue;
        }
        else if (str.find("替换项的大小策略2") != string::npos){
            StrategyParam::termRewritingSize  = 3;
            continue;
        }
         if (str.find("宽深策略0") != string::npos){
            StrategyParam::widthDeep = 0;
            continue;
        }
        else if (str.find("宽深策略1") != string::npos){
            StrategyParam::widthDeep = 1;
            continue;
        }
        else if (str.find("宽深策略2") != string::npos){
            StrategyParam::widthDeep = 2;
            continue;
        }
       if (str.find("演绎深度策略") != string::npos){
            StrategyParam::deductDeep = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("演绎宽度策略") != string::npos){
            StrategyParam::deducWidth = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("迭代次数") != string::npos){
            StrategyParam::iterTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
         if (str.find("迭代轮数") != string::npos){
            StrategyParam::iterRing = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
         if (str.find("时间限制") != string::npos){
            StrategyParam::timeLimit = stod(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("内存限制") != string::npos){
            StrategyParam::memLimit = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("中间归结式冗余判断") != string::npos){
            StrategyParam::midRJudge = true;
            continue;
        }
        else if(str.find("中间归结式冗余不判断") != string::npos)
        {
            StrategyParam::midRJudge = false;
            continue;
        }
        if (str.find("演绎顺序0") != string::npos){
            StrategyParam::deductMode = 0;
            continue;
        }
        else if(str.find("演绎顺序1") != string::npos)
        {
            StrategyParam::deductMode = 1;
            continue;
        }
        if (str.find("演绎最大深度") != string::npos){
            StrategyParam::deduceDepth = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("重复子句次数") != string::npos){
            StrategyParam::claReUseTimes = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::claReUseTimesTmp = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("浸透方法0") != string::npos){
            StrategyParam::useSaturate = true;
            continue;
        }
        else if(str.find("浸透方法1") != string::npos)
        {
            StrategyParam::useSaturate = false;
            continue;
        }
        if (str.find("重复单元子句策略0") != string::npos){
            StrategyParam::useCpUintCla = true;
            continue;
        }
        else if(str.find("重复单元子句策略1") != string::npos)
        {
            StrategyParam::useCpUintCla = false;
            continue;
        }
        if (str.find("使用结合系统策略0") != string::npos){
            StrategyParam::useCombinedSys  = 0;
            continue;
        }
        else if(str.find("使用结合系统策略1") != string::npos)
        {
            StrategyParam::useCombinedSys  = 1;
            continue;
        }
        else if(str.find("使用结合系统策略2") != string::npos)
        {
            StrategyParam::useCombinedSys  = 2;
            continue;
        }
        else if(str.find("使用结合系统策略3") != string::npos)
        {
            StrategyParam::useCombinedSys  = 3;
            continue;
        }
        if (str.find("结合方式策略0") != string::npos){
            StrategyParam::useCombinedSysMethod  = 0;
            continue;
        }
        else if(str.find("结合方式策略1") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 1;
            continue;
        }
        else if(str.find("结合方式策略2") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 2;
            continue;
        }
        else if(str.find("结合方式策略3") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 3;
            continue;
        }
        else if(str.find("结合方式策略4") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 4;
            continue;
        }
        else if(str.find("结合方式策略5") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 5;
            continue;
        }
        else if(str.find("结合方式策略6") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 6;
            continue;
        }
        else if(str.find("结合方式策略7") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 7;
            continue;
        }
        else if(str.find("结合方式策略8") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 8;
            continue;
        }
        else if(str.find("结合方式策略9") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 9;
            continue;
        }
        else if(str.find("结合方式策略10") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 10;
            continue;
        }
        else if(str.find("结合方式策略11") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 11;
            continue;
        }
        else if(str.find("结合方式策略12") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 12;
            continue;
        }
        else if(str.find("结合方式策略13") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 13;
            continue;
        }
        if (str.find("结合R策略0") != string::npos){
            StrategyParam::combinedRMode  = 0;
            continue;
        }
        else if(str.find("结合R策略1") != string::npos)
        {
            StrategyParam::combinedRMode  = 1;
            continue;
        }
        else if(str.find("结合R策略2") != string::npos)
        {
            StrategyParam::combinedRMode  = 2;
            continue;
        }
        else if(str.find("结合R策略3") != string::npos)
        {
            StrategyParam::combinedRMode  = 3;
            continue;
        }
        if(str.find("预处理结合策略0") != string::npos){
            StrategyParam::preprocess  = 1;
            continue;
        }
        else if(str.find("预处理结合策略1") != string::npos){
            StrategyParam::preprocess  = 0;
            continue;
        }
        if ((str.find("因子归结预处理") != string::npos)&&(str.find("不因子归结预处理") == string::npos)){
            StrategyParam::factorRes = true;
            continue;
        }
        else if(str.find("不因子归结预处理") != string::npos)
        {
            StrategyParam::factorRes = false;
            continue;
        }
         if ((str.find("等词归结预处理") != string::npos)&&(str.find("不等词归结预处理") == string::npos)){
            StrategyParam::eqnRes  = true;
            continue;
        }
        else if(str.find("不等词归结预处理") != string::npos)
        {
            StrategyParam::eqnRes  = false;
            continue;
        }
         if ((str.find("删除纯文字子句") != string::npos)&&(str.find("不删除纯文字子句") == string::npos)){
            StrategyParam::delPureCla  = true;
            continue;
        }
        else if(str.find("不删除纯文字子句") != string::npos)
        {
            StrategyParam::delPureCla  = false;
            continue;
        }
        if ((str.find("目标子句预处理") != string::npos)&&(str.find("不目标子句预处理") == string::npos)){
            StrategyParam::goalCla  = true;
            continue;
        }
        else if(str.find("不目标子句预处理") != string::npos)
        {
            StrategyParam::goalCla  = false;
            continue;
        }
         if (str.find("单元子句排序规则0") != string::npos){
            StrategyParam::unitSortRule = 0;
            continue;
        }
        else if (str.find("单元子句排序规则1") != string::npos){
            StrategyParam::unitSortRule = 1;
            continue;
        }
        else if (str.find("单元子句排序规则2") != string::npos){
            StrategyParam::unitSortRule = 2;
            continue;
        }
        else if (str.find("单元子句排序规则3") != string::npos){
            StrategyParam::unitSortRule = 3;
            continue;
        }
        else if (str.find("单元子句排序规则4") != string::npos){
            StrategyParam::unitSortRule = 4;
            continue;
        }
        else if (str.find("单元子句排序规则5") != string::npos){
            StrategyParam::unitSortRule = 5;
            continue;
        }
        else if (str.find("单元子句排序规则6") != string::npos){
            StrategyParam::unitSortRule = 6;
            continue;
        }
        else if (str.find("单元子句排序规则7") != string::npos){
            StrategyParam::unitSortRule = 7;
            continue;
        }
        else if (str.find("单元子句排序规则8") != string::npos){
            StrategyParam::unitSortRule = 8;
            continue;
        }
        if (str.find("子句综合函数复杂度-1") != string::npos){
             StrategyParam::claFuncComp = -1;
             StrategyParam::funcFixDeepth = 36;
            continue;
        }
        else if (str.find("子句综合函数复杂度0") != string::npos) {
            StrategyParam::claFuncComp = 0;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 1;
            continue;
        }
        else if (str.find("子句综合函数复杂度1") != string::npos){
            StrategyParam::claFuncComp = 1;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + StrategyParam::funcOrgFixDeepthLessMax;
            continue;
        }
        else if (str.find("子句综合函数复杂度2") != string::npos){
            StrategyParam::claFuncComp = 2;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*2;
            continue;
        }
        else if (str.find("子句综合函数复杂度3") != string::npos){
            StrategyParam::claFuncComp = 3;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*3;
            continue;
        }
        else if (str.find("子句综合函数复杂度4") != string::npos){
            StrategyParam::claFuncComp = 4;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 10;
            continue;
        }
        if (str.find("单元子句更换方式0") != string::npos) {
            StrategyParam::unitClaUpdate = 0;
            continue;
        }
        else if (str.find("单元子句更换方式1") != string::npos) {
            StrategyParam::unitClaUpdate = 1;
            continue;
        } else if (str.find("单元子句更换方式2") != string::npos) {
            StrategyParam::unitClaUpdate = 2;
            continue;
        }
       if (str.find("非单元子句之间归结") != string::npos){
            StrategyParam::noUnitRes = true;
            continue;
        }
        else if(str.find("非单元子句之间不归结") != string::npos)
        {
            StrategyParam::noUnitRes = false;
            continue;
        }
        if (str.find("非单元子句约简与结论判断") != string::npos){
            StrategyParam::noUnitSimplify = true;
            continue;
        }
        else if(str.find("非单元子句约简与结论不判断") != string::npos)
        {
            StrategyParam::noUnitSimplify = false;
            continue;
        }
        if ((str.find("拆分三角形输出") != string::npos)&&(str.find("不拆分三角形输出") == string::npos)){
            StrategyParam::divideTri = true;
            continue;
        }
        else if(str.find("不拆分三角形输出") != string::npos)
        {
            StrategyParam::divideTri = false;
            continue;
        }
        if ((str.find("删除无法判定记录:") != string::npos)&&(str.find("不删除无法判定记录:") == string::npos)){
            StrategyParam::delRecord = true;
            continue;
        }
        else if(str.find("不删除无法判定记录:") != string::npos)
        {
            StrategyParam::delRecord = false;
            continue;
        }
        if ((str.find("优先生成文字少的子句:") != string::npos)&&(str.find("不优先生成文字少的子句:") == string::npos)){
            StrategyParam::genLitClause = true;
            continue;
        }
        else if(str.find("不优先生成文字少的子句:") != string::npos)
        {
            StrategyParam::genLitClause = false;
            continue;
        }
        if (str.find("多组合策略模式0") != string::npos) {
            StrategyParam::strategyMode = 0;
            continue;
        }
        else if (str.find("多组合策略模式1") != string::npos) {
            StrategyParam::strategyMode = 1;
            continue;
        }
        else if (str.find("多组合策略模式2") != string::npos) {
            StrategyParam::strategyMode = 0;
            continue;
        }
        if (str.find("非单元子句限制策略0") != string::npos) {
            StrategyParam::noUintCla = 0;
            continue;
        }
        else if (str.find("非单元子句限制策略1") != string::npos) {
            StrategyParam::noUintCla = 1;
            continue;
        }
        else if (str.find("非单元子句限制策略2") != string::npos) {
            StrategyParam::noUintCla = 2;
            continue;
        }
        else if (str.find("非单元子句限制策略3") != string::npos) {
            StrategyParam::noUintCla = 3;
            continue;
        }
        else if (str.find("非单元子句限制策略4") != string::npos) {
            StrategyParam::noUintCla = 4;
            continue;
        }
        else if (str.find("非单元子句限制策略5") != string::npos) {
            StrategyParam::noUintCla = 5;
            continue;
        } else if (str.find("非单元子句限制策略6") != string::npos) {
            StrategyParam::noUintCla = 6;
            continue;
        } else if (str.find("非单元子句限制策略7") != string::npos) {
            StrategyParam::noUintCla = 7;
            continue;
        } else if (str.find("非单元子句限制策略8") != string::npos) {
            StrategyParam::noUintCla = 8;
            continue;
        }
        if (str.find("目标深度模式0") != string::npos) {
            StrategyParam::goalDeepth = 2;
            continue;
        } else if (str.find("目标深度模式1") != string::npos) {
            StrategyParam::goalDeepth = 3;
            continue;
        } else if (str.find("目标深度模式2") != string::npos) {
            StrategyParam::goalDeepth = 4;
            continue;
        }
        else if (str.find("目标深度模式3") != string::npos) {
            StrategyParam::goalDeepth = 5;
            continue;
        } else if (str.find("目标深度模式4") != string::npos) {
            StrategyParam::goalDeepth = 6;
            continue;
        } else if (str.find("目标深度模式5") != string::npos) {
            StrategyParam::goalDeepth = 7;
            continue;
        } else if (str.find("目标深度模式6") != string::npos) {
            StrategyParam::goalDeepth = 8;
            continue;
        } else if (str.find("目标深度模式7") != string::npos) {
            StrategyParam::goalDeepth = 9;
            continue;
        }
        else if (str.find("目标深度模式8") != string::npos) {
            StrategyParam::goalDeepth = 10;
            continue;
        }
        else if (str.find("目标深度模式9") != string::npos) {
            StrategyParam::goalDeepth = 200;
            continue;
        }
        if (str.find("锁子句约简模式0") != string::npos) {
            StrategyParam::lockType = 1;
            continue;
        }
        else if (str.find("锁子句约简模式1") != string::npos) {
            StrategyParam::lockType = 2;
            continue;
        }
        else if (str.find("锁子句约简模式2") != string::npos){
             StrategyParam::lockType = 3;
            continue;
        }
        else if (str.find("锁子句约简模式3") != string::npos){
             StrategyParam::lockType = 4;
            continue;
        }
        else if (str.find("锁子句约简模式4") != string::npos){
             StrategyParam::lockType = 5;
            continue;
        }
        else if (str.find("锁子句约简模式5") != string::npos){
             StrategyParam::lockType = 0;
            continue;
        }
        if (str.find("冗余判断策略0") != string::npos){
             StrategyParam::termReRedund = true;
            continue;
        }
        else if (str.find("冗余判断策略1") != string::npos){
             StrategyParam::termReRedund = false;
            continue;
        }
    }
}

void FileOp::OperStrategy(string src,vector<string>* fileName)
{
    DIR* dir;
    struct dirent* ptr;
    dir = opendir(src.c_str());
    if(dir == nullptr){
        return;
    }
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if ((name.find("strategy") != string::npos) && (suffix == "txt")) {
            fileName->push_back(FileOp::strategyFile + "/" + name);
        }
    }
    closedir(dir);
}

int FileOp::strategyFileSizeFunc(string src){
    int size = 0;
    DIR* dir;
    struct dirent* ptr;
    dir = opendir(src.c_str());
    if(dir == nullptr){
        return -1;
    }
    while ((ptr = readdir(dir)) != NULL) {
        string name(ptr->d_name);
        size_t posEnd = name.find_last_of(".");
        string suffix = name.substr(posEnd + 1);
        if ((name.find("strategy") != string::npos) && (suffix == "txt")) {
            ++size;
        }
    }
    closedir(dir);
    return size;
}

string FileOp::findStrategy(string path, int len)
{
    if(len == 0){
        FileOp::StrategyfileName.clear();
        OperStrategy(path, &FileOp::StrategyfileName);
        sort(FileOp::StrategyfileName.begin(),FileOp::StrategyfileName.end());
    }
    if((FileOp::StrategyfileName.size() == 0) || (len < 0) || (len >= FileOp::StrategyfileName.size()))
        return nullptr;
    return FileOp::StrategyfileName[len];
}

string FileOp::findStrategyTptp(string path, int len)
{
    FileOp::StrategyfileName.clear();
    OperStrategy(path, &FileOp::StrategyfileName);
    sort(FileOp::StrategyfileName.begin(), FileOp::StrategyfileName.end());

    if ((FileOp::StrategyfileName.size() == 0) || (len < 0) || (len >= FileOp::StrategyfileName.size()))
        return nullptr;
    return FileOp::StrategyfileName[len];
}

long FileOp::getMem()
{
    FILE *fd;
    char buff[256];
    fd = fopen("/proc/meminfo","r");
    if(fd == nullptr){
        return 200000;
    }
    long memFree = 0;
    long cachedFree = 0;
    while((fgets(buff,sizeof(buff),fd)) != NULL)
    {
        string strMem(buff);
        if(strMem.find("MemFree") != string::npos)
        {
            int pos = strMem.find("MemFree") + 8;
            strMem = strMem.substr(pos);
            TrimStr(strMem);
            pos = strMem.find(" ");
            strMem = strMem.substr(0,pos);
            memFree = atol(strMem.c_str());
        }
        else if((strMem.find("Cached") != string::npos) && (strMem.find("SwapCached") == string::npos))
        {
            int pos = strMem.find("Cached") + 7;
            strMem = strMem.substr(pos);
            TrimStr(strMem);
            pos = strMem.find(" ");
            strMem = strMem.substr(0,pos);
            cachedFree = atol(strMem.c_str());            
        }
    }
    fclose(fd);
    return memFree+cachedFree;
}

void FileOp::getRes(int res[3])
{
    FILE *fd;
    UINT32 a=0,b=0,c=0;
    char buff[256];
    vector<string> path;
    string resPath = homePath + "/Desktop/proofRes.txt";
    if(StrategyParam::orForCompition)
        resPath = FileOp::workSpace + "/proofRes.txt";
    if(access(resPath.c_str(), F_OK) == 0) {
        ;
    }
    else
        return;
    fd = fopen(resPath.c_str(),"r");
    while((fgets(buff,sizeof(buff),fd)) != NULL)
    {
        string strMem(buff);
        if(strMem.find("不可满足") != string::npos)
        {
            path.push_back(homePath + "/Desktop/output/" + strMem.substr(0,strMem.find_first_of(":")));
            a++;
        }
        else if(strMem.find("可满足") != string::npos)
        {
            b++;
        }
        else if(strMem.find("无法判定") != string::npos)
        {
            c++;
        }
    }
    res[0]=a;
    res[1]=b;
    res[2]=c;
    fclose(fd);
}

void FileOp::clearRes()
{
    FILE *fd;
    string resPath = homePath + "/Desktop/proofRes.txt";
    if(StrategyParam::orForCompition)
        resPath = FileOp::workSpace + "/proofRes.txt";
    if(access(resPath.c_str(), F_OK) == 0) {
        fd = fopen(resPath.c_str(), "w+");
        fclose(fd);
    }
}

void FileOp::readStrategy()
{
    FILE *fd;
     string resPath = homePath + "/Desktop/strategy.txt";
     if(StrategyParam::orForCompition)
        resPath = FileOp::appPath + "/strategy.txt";
    fd = fopen(resPath.c_str(),"r"); 
    if(fd == NULL)
        return;
    char buff[256];
    while((fgets(buff,sizeof(buff),fd)) != NULL)
    {
        string str(buff);
        if (str.find("单元子句选取策略0") != string::npos){
            StrategyParam::unitChoose = 0;
            continue;
        }
        else if (str.find("单元子句选取策略1") != string::npos){
            StrategyParam::unitChoose = 1;
            continue;
        }
        else if (str.find("单元子句选取策略2") != string::npos){
            StrategyParam::unitChoose = 2;
            continue;
        }
        else if (str.find("单元子句选取策略3") != string::npos){
            StrategyParam::unitChoose = 3;
            continue;
        }
        else if (str.find("单元子句选取策略4") != string::npos){
            StrategyParam::unitChoose = 4;
            continue;
        }
        if (str.find("单元子句归结次数策略0") != string::npos){
            StrategyParam::unitDeduct = 0;
            continue;
        }
        else if (str.find("单元子句归结次数策略1") != string::npos){
            StrategyParam::unitDeduct = 1;
            continue;
        }
        else if (str.find("单元子句归结次数策略2") != string::npos){
            StrategyParam::unitDeduct = 2;
            continue;
        }
        if (str.find("单元子句冗余次数策略0") != string::npos){
            StrategyParam::unitRedunt = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数策略1") != string::npos){
            StrategyParam::unitRedunt = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数策略2") != string::npos){
            StrategyParam::unitRedunt = 2;
            continue;
        }
        if (str.find("单元子句稳定度策略0") != string::npos){
            StrategyParam::unitSteady = 0;
            continue;
        }
        else if (str.find("单元子句稳定度策略1") != string::npos){
            StrategyParam::unitSteady = 1;
            continue;
        }
        else if (str.find("单元子句稳定度策略2") != string::npos){
            StrategyParam::unitSteady = 2;
            continue;
        }
        if (str.find("单元子句函数嵌套层策略0") != string::npos){
            StrategyParam::unitFuncLayer = 0;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略1") != string::npos){
            StrategyParam::unitFuncLayer = 1;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略2") != string::npos){
            StrategyParam::unitFuncLayer = 2;
            continue;
        }
        if (str.find("候选子句选取策略0") != string::npos){
            StrategyParam::candChoose = 0;
            continue;
        }
        else if (str.find("候选子句选取策略1") != string::npos){
            StrategyParam::candChoose = 1;
            continue;
        }
        else if (str.find("候选子句选取策略2") != string::npos){
            StrategyParam::candChoose = 2;
            continue;
        }
        else if (str.find("候选子句选取策略3") != string::npos){
            StrategyParam::candChoose = 3;
            continue;
        }
        else if (str.find("候选子句选取策略4") != string::npos){
            StrategyParam::candChoose = 4;
            continue;
        }
        if (str.find("候选子句归结次数策略0") != string::npos){
            StrategyParam::candDeduct = 0;
            continue;
        }
        else if (str.find("候选子句归结次数策略1") != string::npos){
            StrategyParam::candDeduct = 1;
            continue;
        }
        else if (str.find("候选子句归结次数策略2") != string::npos){
            StrategyParam::candDeduct = 2;
            continue;
        }
        if (str.find("候选子句冗余次数策略0") != string::npos) {
            StrategyParam::candRedunt = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数策略1") != string::npos){
            StrategyParam::candRedunt = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数策略2") != string::npos){
            StrategyParam::candRedunt = 2;
            continue;
        }
        if (str.find("候选子句文字数策略0") != string::npos) {
            StrategyParam::candClause = 0;
            continue;
        }
        else if (str.find("候选子句文字数策略1") != string::npos){
            StrategyParam::candClause = 1;
            continue;
        }
        else if (str.find("候选子句文字数策略2") != string::npos){
            StrategyParam::candClause = 2;
            continue;
        }
       if (str.find("候选子句稳定度策略0") != string::npos){
            StrategyParam::candSteady = 0;
            continue;
        }
        else if (str.find("候选子句稳定度策略1") != string::npos){
            StrategyParam::candSteady = 1;
            continue;
        }
        else if (str.find("候选子句稳定度策略2") != string::npos){
            StrategyParam::candSteady = 2;
            continue;
        }
         if (str.find("单元子句归结次数最大值策略") != string::npos){          
            StrategyParam::unitDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("单元子句归结次数更新策略0") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略1") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略2") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略3") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略4") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 4;
            continue;
        }
        if (str.find("单元子句冗余次数最大值策略") != string::npos){
            StrategyParam::unitReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
         if (str.find("单元子句冗余次数更新策略0") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略1") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略2") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略3") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略4") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 4;
            continue;
        }
        if (str.find("候选子句归结次数最大值策略") != string::npos){
            StrategyParam::candDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("候选子句归结次数更新策略0") != string::npos){
            StrategyParam::candDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略1") != string::npos){
            StrategyParam::candDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略2") != string::npos){
            StrategyParam::candDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略3") != string::npos){
            StrategyParam::candDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略4") != string::npos){
            StrategyParam::candDeductTimesUpdate = 4;
            continue;
        }
       if (str.find("候选子句冗余次数最大值策略") != string::npos){
            StrategyParam::candReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
         if (str.find("候选子句冗余次数更新策略0") != string::npos){
            StrategyParam::candReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略1") != string::npos){
            StrategyParam::candReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略2") != string::npos){
            StrategyParam::candReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略3") != string::npos){
            StrategyParam::candReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略") != string::npos){
            StrategyParam::candReduntTimesUpdate = 4;
            continue;
        }
        if (str.find("候选子句文字策略0") != string::npos){
            StrategyParam::candLiteral = 0;
            continue;
        }
        else if (str.find("候选子句文字策略1") != string::npos){
            StrategyParam::candLiteral = 1;
            continue;
        }
        else if (str.find("候选子句文字策略2") != string::npos){
            StrategyParam::candLiteral = 2;
            continue;
        }
        if (str.find("候选子句文字归结次数策略0") != string::npos){
            StrategyParam::candLiteralDeductTimes = 0;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略1") != string::npos){
            StrategyParam::candLiteralDeductTimes = 1;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略2") != string::npos){
            StrategyParam::candLiteralDeductTimes = 2;
            continue;
        }
        if (str.find("候选子句文字稳定度策略0") != string::npos){
            StrategyParam::candLiteralSteady = 0;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略1") != string::npos){
            StrategyParam::candLiteralSteady = 1;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略2") != string::npos){
            StrategyParam::candLiteralSteady = 2;
            continue;
        }
        if ((str.find("R权重赋值策略0:") != string::npos)){
            StrategyParam::useRandrom = true;
            continue;
        }
        else if(str.find("R权重赋值策略1:") != string::npos)
        {
            StrategyParam::useRandrom = false;
            continue;
        }
        if ((str.find("不允许小于原始子句文字最大数:") != string::npos)){
            StrategyParam::Rsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句文字最大数:") != string::npos)
        {
            StrategyParam::Rsmall = true;
            continue;
        }
         if ((str.find("不允许小于原始子句层数最大数:") != string::npos)){
            StrategyParam::RFsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句层数最大数:") != string::npos)
        {
            StrategyParam::RFsmall = true;
            continue;
        }
        if ((str.find("不允许R因子归结:") != string::npos)){
            StrategyParam::RRes = false;
            continue;
        }
        else if(str.find("允许R因子归结:") != string::npos)
        {
            StrategyParam::RRes = true;
            continue;
        }
        if (str.find("R文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_NUM = stoi(str.substr(str.find_first_of(":") + 1));
            if ((StrategyParam::R_MAX_NUM < StrategyParam::R_INIT_MAX_NUM) && !StrategyParam::Rsmall) {
                StrategyParam::R_MAX_NUM = StrategyParam::R_INIT_MAX_NUM;
                StrategyParam::R_MAX_NUM_TMP = StrategyParam::R_INIT_MAX_NUM;
            }
            continue;
        }
        if (str.find("R函数嵌套层") != string::npos){
            StrategyParam::R_MAX_FUNCLAYER = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_FUNCLAYER_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            if ((StrategyParam::R_MAX_FUNCLAYER < StrategyParam::R_INIT_MAX_FUNCLAYER) && !StrategyParam::RFsmall) {
                StrategyParam::R_MAX_FUNCLAYER = StrategyParam::R_INIT_MAX_FUNCLAYER* 2+1;
                StrategyParam::R_MAX_FUNCLAYER_TMP = StrategyParam::R_INIT_MAX_FUNCLAYER* 2+1;
            }
            continue;
        }
        if (str.find("R权重大小") != string::npos){
            StrategyParam::R_Weight = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("R2文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_NOPAIR = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("R文字冗余策略0") != string::npos){
            StrategyParam::litRundent = 1;
            continue;
        }
        else if(str.find("R文字冗余策略1") != string::npos)
        {
            StrategyParam::litRundent = 0;
            continue;
        }
        if (str.find("中间归结式生成策略0") != string::npos){
            StrategyParam::midR = 0;
            continue;
        }
        else if(str.find("中间归结式生成策略1") != string::npos)
        {
            StrategyParam::midR = 1;
            continue;
        }
        else if(str.find("中间归结式生成策略2") != string::npos)
        {
            StrategyParam::midR = 2;
            continue;
        }
        else if(str.find("中间归结式生成策略3") != string::npos)
        {
            StrategyParam::midR = 3;
            continue;
        }
        else if(str.find("中间归结式生成策略4") != string::npos)
        {
            StrategyParam::midR = 4;
            continue;
        }
        else if(str.find("中间归结式生成策略5") != string::npos)
        {
            StrategyParam::midR = 5;
            continue;
        }
        else if(str.find("中间归结式生成策略6") != string::npos)
        {
            StrategyParam::midR = 6;
            continue;
        }
        else if(str.find("中间归结式生成策略7") != string::npos)
        {
            StrategyParam::midR = 1000;
            continue;
        }
         if (str.find("项重写策略0") != string::npos){
            StrategyParam::termRewriting = 0;
            continue;
        }
        else if (str.find("项重写策略1") != string::npos){
            StrategyParam::termRewriting = 1;
            continue;
        }
        else if (str.find("项重写策略2") != string::npos){
            StrategyParam::termRewriting = 2;
            continue;
        }
         if (str.find("替换项的大小策略0") != string::npos){
            StrategyParam::termRewritingSize  = 1;
            continue;
        }
        else if (str.find("替换项的大小策略1") != string::npos){
            StrategyParam::termRewritingSize  = 2;
            continue;
        }
        else if (str.find("替换项的大小策略2") != string::npos){
            StrategyParam::termRewritingSize  = 3;
            continue;
        }
         if (str.find("宽深策略0") != string::npos){
            StrategyParam::widthDeep = 0;
            continue;
        }
        else if (str.find("宽深策略1") != string::npos){
            StrategyParam::widthDeep = 1;
            continue;
        }
        else if (str.find("宽深策略2") != string::npos){
            StrategyParam::widthDeep = 2;
            continue;
        }
       if (str.find("演绎深度策略") != string::npos){
            StrategyParam::deductDeep = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("演绎宽度策略") != string::npos){
            StrategyParam::deducWidth = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("迭代次数") != string::npos){
            StrategyParam::iterTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
         if (str.find("迭代轮数") != string::npos){
            StrategyParam::iterRing = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
         if (str.find("时间限制") != string::npos){
            StrategyParam::timeLimit = stod(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("内存限制") != string::npos){
            StrategyParam::memLimit = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("中间归结式冗余判断") != string::npos){
            StrategyParam::midRJudge = true;
            continue;
        }
        else if(str.find("中间归结式冗余不判断") != string::npos)
        {
            StrategyParam::midRJudge = false;
            continue;
        }
        if (str.find("演绎顺序0") != string::npos){
            StrategyParam::deductMode = 0;
            continue;
        }
        else if(str.find("演绎顺序1") != string::npos)
        {
            StrategyParam::deductMode = 1;
            continue;
        }
        if (str.find("演绎最大深度") != string::npos){
            StrategyParam::deduceDepth = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("重复子句次数") != string::npos){
            StrategyParam::claReUseTimes = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::claReUseTimesTmp = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("浸透方法0") != string::npos){
            StrategyParam::useSaturate = true;
            continue;
        }
        else if(str.find("浸透方法1") != string::npos)
        {
            StrategyParam::useSaturate = false;
            continue;
        }
        if (str.find("重复单元子句策略0") != string::npos){
            StrategyParam::useCpUintCla = true;
            continue;
        }
        else if(str.find("重复单元子句策略1") != string::npos)
        {
            StrategyParam::useCpUintCla = false;
            continue;
        }
        if (str.find("使用结合系统策略0") != string::npos){
            StrategyParam::useCombinedSys  = 0;
            continue;
        }
        else if(str.find("使用结合系统策略1") != string::npos)
        {
            StrategyParam::useCombinedSys  = 1;
            continue;
        }
        else if(str.find("使用结合系统策略2") != string::npos)
        {
            StrategyParam::useCombinedSys  = 2;
            continue;
        }
        else if(str.find("使用结合系统策略3") != string::npos)
        {
            StrategyParam::useCombinedSys  = 3;
            continue;
        }
        if (str.find("结合方式策略0") != string::npos){
            StrategyParam::useCombinedSysMethod  = 0;
            continue;
        }
        else if(str.find("结合方式策略1") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 1;
            continue;
        }
        else if(str.find("结合方式策略2") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 2;
            continue;
        }
        else if(str.find("结合方式策略3") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 3;
            continue;
        }
        else if(str.find("结合方式策略4") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 4;
            continue;
        }
        else if(str.find("结合方式策略5") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 5;
            continue;
        }
        else if(str.find("结合方式策略6") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 6;
            continue;
        }
        else if(str.find("结合方式策略7") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 7;
            continue;
        }
        else if(str.find("结合方式策略8") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 8;
            continue;
        }
        else if(str.find("结合方式策略9") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 9;
            continue;
        }
        else if(str.find("结合方式策略10") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 10;
            continue;
        }
        else if(str.find("结合方式策略11") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 11;
            continue;
        }
        else if(str.find("结合方式策略12") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 12;
            continue;
        }
        else if(str.find("结合方式策略13") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 13;
            continue;
        }
        if (str.find("结合R策略0") != string::npos){
            StrategyParam::combinedRMode  = 0;
            continue;
        }
        else if(str.find("结合R策略1") != string::npos)
        {
            StrategyParam::combinedRMode  = 1;
            continue;
        }
        else if(str.find("结合R策略2") != string::npos)
        {
            StrategyParam::combinedRMode  = 2;
            continue;
        }
        else if(str.find("结合R策略3") != string::npos)
        {
            StrategyParam::combinedRMode  = 3;
            continue;
        }
        if (str.find("等词使用频度策略0") != string::npos){
            StrategyParam::equalityUsedFrq  = 0;
            continue;
        }
        else if(str.find("等词使用频度策略1") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 1;
            continue;
        }
        else if(str.find("等词使用频度策略2") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 2;
            continue;
        } 
        if(str.find("预处理结合策略0") != string::npos){
            StrategyParam::preprocess  = 1;
            continue;
        }
        else if(str.find("预处理结合策略1") != string::npos){
            StrategyParam::preprocess  = 0;
            continue;
        }
        if ((str.find("因子归结预处理") != string::npos)&&(str.find("不因子归结预处理") == string::npos)){
            StrategyParam::factorRes = true;
            continue;
        }
        else if(str.find("不因子归结预处理") != string::npos)
        {
            StrategyParam::factorRes = false;
            continue;
        }
         if ((str.find("等词归结预处理") != string::npos)&&(str.find("不等词归结预处理") == string::npos)){
            StrategyParam::eqnRes  = true;
            continue;
        }
        else if(str.find("不等词归结预处理") != string::npos)
        {
            StrategyParam::eqnRes  = false;
            continue;
        }
         if ((str.find("删除纯文字子句") != string::npos)&&(str.find("不删除纯文字子句") == string::npos)){
            StrategyParam::delPureCla  = true;
            continue;
        }
        else if(str.find("不删除纯文字子句") != string::npos)
        {
            StrategyParam::delPureCla  = false;
            continue;
        }
        if ((str.find("目标子句预处理") != string::npos)&&(str.find("不目标子句预处理") == string::npos)){
            StrategyParam::goalCla  = true;
            continue;
        }
        else if(str.find("不目标子句预处理") != string::npos)
        {
            StrategyParam::goalCla  = false;
            continue;
        }
         if (str.find("单元子句排序规则0") != string::npos){
            StrategyParam::unitSortRule = 0;
            continue;
        }
        else if (str.find("单元子句排序规则1") != string::npos){
            StrategyParam::unitSortRule = 1;
            continue;
        }
        else if (str.find("单元子句排序规则2") != string::npos){
            StrategyParam::unitSortRule = 2;
            continue;
        }
        else if (str.find("单元子句排序规则3") != string::npos){
            StrategyParam::unitSortRule = 3;
            continue;
        }
        else if (str.find("单元子句排序规则4") != string::npos){
            StrategyParam::unitSortRule = 4;
            continue;
        }
        else if (str.find("单元子句排序规则5") != string::npos){
            StrategyParam::unitSortRule = 5;
            continue;
        }
        else if (str.find("单元子句排序规则6") != string::npos){
            StrategyParam::unitSortRule = 6;
            continue;
        }
        else if (str.find("单元子句排序规则7") != string::npos){
            StrategyParam::unitSortRule = 7;
            continue;
        }
        else if (str.find("单元子句排序规则8") != string::npos){
            StrategyParam::unitSortRule = 8;
            continue;
        }
        if (str.find("子句综合函数复杂度-1") != string::npos) {
            StrategyParam::claFuncComp = -1;
            StrategyParam::funcFixDeepth = 36;
            continue;
        }
        else if (str.find("子句综合函数复杂度0") != string::npos) {
            StrategyParam::claFuncComp = 0;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 1;
            continue;
        }
        else if (str.find("子句综合函数复杂度1") != string::npos){
            StrategyParam::claFuncComp = 1;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + StrategyParam::funcOrgFixDeepthLessMax;
            continue;
        }
        else if (str.find("子句综合函数复杂度2") != string::npos){
            StrategyParam::claFuncComp = 2;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*2;
            continue;
        }
        else if (str.find("子句综合函数复杂度3") != string::npos){
            StrategyParam::claFuncComp = 3;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*3;
            continue;
        }
        else if (str.find("子句综合函数复杂度4") != string::npos){
            StrategyParam::claFuncComp = 4;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 10;
            continue;
        }
        if (str.find("单元子句更换方式0") != string::npos) {
            StrategyParam::unitClaUpdate = 0;
            continue;
        }
        else if (str.find("单元子句更换方式1") != string::npos) {
            StrategyParam::unitClaUpdate = 1;
            continue;
        }else if (str.find("单元子句更换方式2") != string::npos) {
            StrategyParam::unitClaUpdate = 2;
            continue;
        }
       if (str.find("非单元子句之间归结") != string::npos){
            StrategyParam::noUnitRes = true;
            continue;
        }
        else if(str.find("非单元子句之间不归结") != string::npos)
        {
            StrategyParam::noUnitRes = false;
            continue;
        }
        if (str.find("非单元子句约简与结论判断") != string::npos){
            StrategyParam::noUnitSimplify = true;
            continue;
        }
        else if(str.find("非单元子句约简与结论不判断") != string::npos)
        {
            StrategyParam::noUnitSimplify = false;
            continue;
        }
        if ((str.find("拆分三角形输出") != string::npos)&&(str.find("不拆分三角形输出") == string::npos)){
            StrategyParam::divideTri = true;
            continue;
        }
        else if(str.find("不拆分三角形输出") != string::npos)
        {
            StrategyParam::divideTri = false;
            continue;
        }
        if ((str.find("删除无法判定记录:") != string::npos)&&(str.find("不删除无法判定记录:") == string::npos)){
            StrategyParam::delRecord = true;
            continue;
        }
        else if(str.find("不删除无法判定记录:") != string::npos)
        {
            StrategyParam::delRecord = false;
            continue;
        }
        if ((str.find("优先生成文字少的子句:") != string::npos)&&(str.find("不优先生成文字少的子句:") == string::npos)){
            StrategyParam::genLitClause = true;
            continue;
        }
        else if(str.find("不优先生成文字少的子句:") != string::npos)
        {
            StrategyParam::genLitClause = false;
            continue;
        }
        if (str.find("多组合策略模式0") != string::npos) {
            StrategyParam::strategyMode = 0;
            continue;
        }
        else if (str.find("多组合策略模式1") != string::npos) {
            StrategyParam::strategyMode = 1;
            continue;
        }
        else if (str.find("多组合策略模式2") != string::npos) {
            StrategyParam::strategyMode = 0;
            continue;
        }
        if (str.find("非单元子句限制策略0") != string::npos) {
            StrategyParam::noUintCla = 0;
            continue;
        }
        else if (str.find("非单元子句限制策略1") != string::npos) {
            StrategyParam::noUintCla = 1;
            continue;
        }
        else if (str.find("非单元子句限制策略2") != string::npos) {
            StrategyParam::noUintCla = 2;
            continue;
        }
        else if (str.find("非单元子句限制策略3") != string::npos) {
            StrategyParam::noUintCla = 3;
            continue;
        }
        else if (str.find("非单元子句限制策略4") != string::npos) {
            StrategyParam::noUintCla = 4;
            continue;
        }
        else if (str.find("非单元子句限制策略5") != string::npos) {
            StrategyParam::noUintCla = 5;
            continue;
        }
        else if (str.find("非单元子句限制策略6") != string::npos) {
            StrategyParam::noUintCla = 6;
            continue;
        }
        else if (str.find("非单元子句限制策略7") != string::npos) {
            StrategyParam::noUintCla = 7;
            continue;
        }
        else if (str.find("非单元子句限制策略8") != string::npos) {
            StrategyParam::noUintCla = 8;
            continue;
        }
        if (str.find("目标深度模式0") != string::npos) {
            StrategyParam::goalDeepth = 2;
            continue;
        }
        else if (str.find("目标深度模式1") != string::npos) {
            StrategyParam::goalDeepth = 3;
            continue;
        }
        else if (str.find("目标深度模式2") != string::npos) {
            StrategyParam::goalDeepth = 4;
            continue;
        }
        else if (str.find("目标深度模式3") != string::npos) {
            StrategyParam::goalDeepth = 5;
            continue;
        }
        else if (str.find("目标深度模式4") != string::npos) {
            StrategyParam::goalDeepth = 6;
            continue;
        }
        else if (str.find("目标深度模式5") != string::npos) {
            StrategyParam::goalDeepth = 7;
            continue;
        }
        else if (str.find("目标深度模式6") != string::npos) {
            StrategyParam::goalDeepth = 8;
            continue;
        }
        else if (str.find("目标深度模式7") != string::npos) {
            StrategyParam::goalDeepth = 9;
            continue;
        }
        else if (str.find("目标深度模式8") != string::npos) {
            StrategyParam::goalDeepth = 10;
            continue;
        }
        else if (str.find("目标深度模式9") != string::npos) {
            StrategyParam::goalDeepth = 200;
            continue;
        }
        if (str.find("锁子句约简模式0") != string::npos) {
            StrategyParam::lockType = 1;
            continue;
        }
        else if (str.find("锁子句约简模式1") != string::npos) {
            StrategyParam::lockType = 2;
            continue;
        }
        else if (str.find("锁子句约简模式2") != string::npos) {
            StrategyParam::lockType = 3;
            continue;
        }
        else if (str.find("锁子句约简模式3") != string::npos) {
            StrategyParam::lockType = 4;
            continue;
        }
        else if (str.find("锁子句约简模式4") != string::npos) {
            StrategyParam::lockType = 5;
            continue;
        }
        else if (str.find("锁子句约简模式5") != string::npos) {
            StrategyParam::lockType = 0;
            continue;
        }
        if (str.find("冗余判断策略0") != string::npos) {
            StrategyParam::termReRedund = true;
            continue;
        }
        else if (str.find("冗余判断策略1") != string::npos) {
            StrategyParam::termReRedund = false;
            continue;
        }
    }
    fclose(fd);
}

void FileOp::readStrategyN(int n)
{
    string strFile;
    strFile = FileOp::findStrategy(FileOp::strategyFile, n);
    FileOp::readBatchStrategy(strFile);
}

void FileOp::readStrategyNTptp(int n)
{
    string strFile;
    strFile = FileOp::findStrategyTptp(FileOp::strategyFile, n);
    cout<< "the " + to_string(n+1) + "th used strategy: "<< strFile << endl;
    FileOp::readBatchStrategy(strFile);
}

string FileOp::getStrategyNTptp(int n)
{
    string strFile;
    strFile = FileOp::findStrategyTptp(FileOp::strategyFile, n);
    return strFile;
}

void FileOp::readBatchStrategy(string path)
{
    FILE *fd;
    fd = fopen(path.c_str(),"r"); 
    if(fd == NULL)
        return;
    char buff[256];
    while((fgets(buff,sizeof(buff),fd)) != NULL)
    {
        string str(buff);
        if (str.find("单元子句选取策略0") != string::npos){
            StrategyParam::unitChoose = 0;
            continue;
        }
        else if (str.find("单元子句选取策略1") != string::npos){
            StrategyParam::unitChoose = 1;
            continue;
        }
        else if (str.find("单元子句选取策略2") != string::npos){
            StrategyParam::unitChoose = 2;
            continue;
        }
        else if (str.find("单元子句选取策略3") != string::npos){
            StrategyParam::unitChoose = 3;
            continue;
        }
        else if (str.find("单元子句选取策略4") != string::npos){
            StrategyParam::unitChoose = 4;
            continue;
        }
        if (str.find("单元子句归结次数策略0") != string::npos){
            StrategyParam::unitDeduct = 0;
            continue;
        }
        else if (str.find("单元子句归结次数策略1") != string::npos){
            StrategyParam::unitDeduct = 1;
            continue;
        }
        else if (str.find("单元子句归结次数策略2") != string::npos){
            StrategyParam::unitDeduct = 2;
            continue;
        }
        if (str.find("单元子句冗余次数策略0") != string::npos){
            StrategyParam::unitRedunt = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数策略1") != string::npos){
            StrategyParam::unitRedunt = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数策略2") != string::npos){
            StrategyParam::unitRedunt = 2;
            continue;
        }
        if (str.find("单元子句稳定度策略0") != string::npos){
            StrategyParam::unitSteady = 0;
            continue;
        }
        else if (str.find("单元子句稳定度策略1") != string::npos){
            StrategyParam::unitSteady = 1;
            continue;
        }
        else if (str.find("单元子句稳定度策略2") != string::npos){
            StrategyParam::unitSteady = 2;
            continue;
        }
        if (str.find("单元子句函数嵌套层策略0") != string::npos){
            StrategyParam::unitFuncLayer = 0;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略1") != string::npos){
            StrategyParam::unitFuncLayer = 1;
            continue;
        }
        else if (str.find("单元子句函数嵌套层策略2") != string::npos){
            StrategyParam::unitFuncLayer = 2;
            continue;
        }
        if (str.find("候选子句选取策略0") != string::npos){
            StrategyParam::candChoose = 0;
            continue;
        }
        else if (str.find("候选子句选取策略1") != string::npos){
            StrategyParam::candChoose = 1;
            continue;
        }
        else if (str.find("候选子句选取策略2") != string::npos){
            StrategyParam::candChoose = 2;
            continue;
        }
        else if (str.find("候选子句选取策略3") != string::npos){
            StrategyParam::candChoose = 3;
            continue;
        }
        else if (str.find("候选子句选取策略4") != string::npos){
            StrategyParam::candChoose = 4;
            continue;
        }
        if (str.find("候选子句归结次数策略0") != string::npos){
            StrategyParam::candDeduct = 0;
            continue;
        }
        else if (str.find("候选子句归结次数策略1") != string::npos){
            StrategyParam::candDeduct = 1;
            continue;
        }
        else if (str.find("候选子句归结次数策略2") != string::npos){
            StrategyParam::candDeduct = 2;
            continue;
        }
        if (str.find("候选子句冗余次数策略0") != string::npos) {
            StrategyParam::candRedunt = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数策略1") != string::npos){
            StrategyParam::candRedunt = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数策略2") != string::npos){
            StrategyParam::candRedunt = 2;
            continue;
        }
         if (str.find("候选子句文字数策略0") != string::npos){
            StrategyParam::candClause = 0;
            continue;
        }
        else if (str.find("候选子句文字数策略1") != string::npos){
            StrategyParam::candClause = 1;
            continue;
        }
        else if (str.find("候选子句文字数策略2") != string::npos){
            StrategyParam::candClause = 2;
            continue;
        }
        if(str.find("候选子句稳定度策略0") != string::npos){
            StrategyParam::candSteady = 0;
            continue;
        }
        else if (str.find("候选子句稳定度策略1") != string::npos){
            StrategyParam::candSteady = 1;
            continue;
        }
        else if (str.find("候选子句稳定度策略2") != string::npos){
            StrategyParam::candSteady = 2;
            continue;
        }
        if (str.find("单元子句归结次数最大值策略") != string::npos){
            
            StrategyParam::unitDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("单元子句归结次数更新策略0") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略1") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略2") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略3") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句归结次数更新策略4") != string::npos){
            StrategyParam::unitDeductTimesUpdate = 4;
            continue;
        }
        if (str.find("单元子句冗余次数最大值策略") != string::npos){
            StrategyParam::unitReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("单元子句冗余次数更新策略0") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略1") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略2") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略3") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("单元子句冗余次数更新策略4") != string::npos){
            StrategyParam::unitReduntTimesUpdate = 4;
            continue;
        }
        if (str.find("候选子句归结次数最大值策略") != string::npos){
            StrategyParam::candDeductTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("候选子句归结次数更新策略0") != string::npos){
            StrategyParam::candDeductTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略1") != string::npos){
            StrategyParam::candDeductTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略2") != string::npos){
            StrategyParam::candDeductTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略3") != string::npos){
            StrategyParam::candDeductTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句归结次数更新策略4") != string::npos){
            StrategyParam::candDeductTimesUpdate = 4;
            continue;
        }
       if (str.find("候选子句冗余次数最大值策略") != string::npos){
            StrategyParam::candReduntTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("候选子句冗余次数更新策略0") != string::npos){
            StrategyParam::candReduntTimesUpdate = 0;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略1") != string::npos){
            StrategyParam::candReduntTimesUpdate = 1;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略2") != string::npos){
            StrategyParam::candReduntTimesUpdate = 2;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略3") != string::npos){
            StrategyParam::candReduntTimesUpdate = 3;
            continue;
        }
        else if (str.find("候选子句冗余次数更新策略") != string::npos){
            StrategyParam::candReduntTimesUpdate = 4;
            continue;
        }
        if (str.find("候选子句文字策略0") != string::npos){
            StrategyParam::candLiteral = 0;
            continue;
        }
        else if (str.find("候选子句文字策略1") != string::npos){
            StrategyParam::candLiteral = 1;
            continue;
        }
        else if (str.find("候选子句文字策略2") != string::npos){
            StrategyParam::candLiteral = 2;
            continue;
        }
        if (str.find("候选子句文字归结次数策略0") != string::npos){
            StrategyParam::candLiteralDeductTimes = 0;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略1") != string::npos){
            StrategyParam::candLiteralDeductTimes = 1;
            continue;
        }
        else if (str.find("候选子句文字归结次数策略2") != string::npos){
            StrategyParam::candLiteralDeductTimes = 2;
            continue;
        }
        if (str.find("候选子句文字稳定度策略0") != string::npos){
            StrategyParam::candLiteralSteady = 0;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略1") != string::npos){
            StrategyParam::candLiteralSteady = 1;
            continue;
        }
        else if (str.find("候选子句文字稳定度策略2") != string::npos){
            StrategyParam::candLiteralSteady = 2;
            continue;
        }
        if ((str.find("R权重赋值策略0:") != string::npos)){
            StrategyParam::useRandrom = true;
            continue;
        }
        else if(str.find("R权重赋值策略1:") != string::npos)
        {
            StrategyParam::useRandrom = false;
            continue;
        }
        if ((str.find("不允许小于原始子句文字最大数:") != string::npos)){
            StrategyParam::Rsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句文字最大数:") != string::npos)
        {
            StrategyParam::Rsmall = true;
            continue;
        }
         if ((str.find("不允许小于原始子句层数最大数:") != string::npos)){
            StrategyParam::RFsmall = false;
            continue;
        }
        else if(str.find("允许小于原始子句层数最大数:") != string::npos)
        {
            StrategyParam::RFsmall = true;
            continue;
        }
        if ((str.find("不允许R因子归结:") != string::npos)){
            StrategyParam::RRes = false;
            continue;
        }
        else if(str.find("允许R因子归结:") != string::npos)
        {
            StrategyParam::RRes = true;
            continue;
        }
        if (str.find("R文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_NUM = stoi(str.substr(str.find_first_of(":") + 1));
            if ((StrategyParam::R_MAX_NUM < StrategyParam::R_INIT_MAX_NUM) && !StrategyParam::Rsmall) {
                StrategyParam::R_MAX_NUM = StrategyParam::R_INIT_MAX_NUM;
                StrategyParam::R_MAX_NUM_TMP = StrategyParam::R_INIT_MAX_NUM;
            }
            continue;
        }
        if (str.find("R函数嵌套层") != string::npos){
            StrategyParam::R_MAX_FUNCLAYER = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::R_MAX_FUNCLAYER_TMP = stoi(str.substr(str.find_first_of(":") + 1));
            if((StrategyParam::R_MAX_FUNCLAYER < StrategyParam::R_INIT_MAX_FUNCLAYER) && !StrategyParam::RFsmall) {
                StrategyParam::R_MAX_FUNCLAYER = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
                StrategyParam::R_MAX_FUNCLAYER_TMP = StrategyParam::R_INIT_MAX_FUNCLAYER * 2 + 1;
            }
            continue;
        }
        if (str.find("R权重大小") != string::npos){
            StrategyParam::R_Weight = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("R2文字数大小策略") != string::npos){
            StrategyParam::R_MAX_NUM_NOPAIR = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        }
        if (str.find("R文字冗余策略0") != string::npos){
            StrategyParam::litRundent = 1;
            continue;
        }
        else if(str.find("R文字冗余策略1") != string::npos)
        {
            StrategyParam::litRundent = 0;
            continue;
        }
        if (str.find("中间归结式生成策略0") != string::npos){
            StrategyParam::midR = 0;
            continue;
        }
        else if(str.find("中间归结式生成策略1") != string::npos)
        {
            StrategyParam::midR = 1;
            continue;
        }
        else if(str.find("中间归结式生成策略2") != string::npos)
        {
            StrategyParam::midR = 2;
            continue;
        }
        else if(str.find("中间归结式生成策略3") != string::npos)
        {
            StrategyParam::midR = 3;
            continue;
        }
        else if(str.find("中间归结式生成策略4") != string::npos)
        {
            StrategyParam::midR = 4;
            continue;
        }
        else if(str.find("中间归结式生成策略5") != string::npos)
        {
            StrategyParam::midR = 5;
            continue;
        }
        else if(str.find("中间归结式生成策略6") != string::npos)
        {
            StrategyParam::midR = 6;
            continue;
        }
        else if(str.find("中间归结式生成策略7") != string::npos)
        {
            StrategyParam::midR = 1000;
            continue;
        }
        if (str.find("宽深策略0") != string::npos){
            StrategyParam::widthDeep = 0;
            continue;
        }
        else if (str.find("宽深策略1") != string::npos){
            StrategyParam::widthDeep = 1;
            continue;
        }
        else if (str.find("宽深策略2") != string::npos){
            StrategyParam::widthDeep = 2;
            continue;
        }
        if (str.find("项重写策略0") != string::npos){
            StrategyParam::termRewriting = 0;
            continue;
        }
        else if (str.find("项重写策略1") != string::npos){
            StrategyParam::termRewriting = 1;
            continue;
        }
        else if (str.find("项重写策略2") != string::npos){
            StrategyParam::termRewriting = 2;
            continue;
        }
        if (str.find("替换项的大小策略0") != string::npos){
            StrategyParam::termRewritingSize  = 1;
            continue;
        }
        else if (str.find("替换项的大小策略1") != string::npos){
            StrategyParam::termRewritingSize  = 2;
            continue;
        }
        else if (str.find("替换项的大小策略2") != string::npos){
            StrategyParam::termRewritingSize  = 3;
            continue;
        }
        if (str.find("演绎深度策略") != string::npos){
            StrategyParam::deductDeep = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("演绎宽度策略") != string::npos){
            StrategyParam::deducWidth = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("迭代次数") != string::npos){
            StrategyParam::iterTimes = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("迭代轮数") != string::npos){
            StrategyParam::iterRing = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("时间限制") != string::npos){
            StrategyParam::timeLimit = stod(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("内存限制") != string::npos){
            StrategyParam::memLimit = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("中间归结式冗余判断") != string::npos){
            StrategyParam::midRJudge = true;
            continue;
        }
        else if(str.find("中间归结式冗余不判断") != string::npos)
        {
            StrategyParam::midRJudge = false;
            continue;
        }
        if (str.find("演绎顺序0") != string::npos){
            StrategyParam::deductMode = 0;
            continue;
        }
        else if(str.find("演绎顺序1") != string::npos)
        {
            StrategyParam::deductMode = 1;
            continue;
        }
        if (str.find("演绎最大深度") != string::npos){
            StrategyParam::deduceDepth = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("重复单元子句策略0") != string::npos){
            StrategyParam::useCpUintCla = true;
            continue;
        }
        else if(str.find("重复单元子句策略1") != string::npos)
        {
            StrategyParam::useCpUintCla = false;
            continue;
        }
        if (str.find("重复子句次数") != string::npos){
            StrategyParam::claReUseTimes = stoi(str.substr(str.find_first_of(":") + 1));
            StrategyParam::claReUseTimesTmp = stoi(str.substr(str.find_first_of(":") + 1));
            continue;
        } 
        if (str.find("使用结合系统策略0") != string::npos){
            StrategyParam::useCombinedSys  = 0;
            continue;
        }
        else if(str.find("使用结合系统策略1") != string::npos)
        {
            StrategyParam::useCombinedSys  = 1;
            continue;
        }
        else if(str.find("使用结合系统策略2") != string::npos)
        {
            StrategyParam::useCombinedSys  = 2;
            continue;
        }
        else if(str.find("使用结合系统策略3") != string::npos)
        {
            StrategyParam::useCombinedSys  = 3;
            continue;
        }
        if (str.find("结合方式策略0") != string::npos){
            StrategyParam::useCombinedSysMethod  = 0;
            continue;
        }
        else if(str.find("结合方式策略1") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 1;
            continue;
        }
        else if(str.find("结合方式策略2") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 2;
            continue;
        }
        else if(str.find("结合方式策略3") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 3;
            continue;
        }
        else if(str.find("结合方式策略4") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 4;
            continue;
        }
        else if(str.find("结合方式策略5") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 5;
            continue;
        }
        else if(str.find("结合方式策略6") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 6;
            continue;
        }
        else if(str.find("结合方式策略7") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 7;
            continue;
        }
        else if(str.find("结合方式策略8") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 8;
            continue;
        }
        else if(str.find("结合方式策略9") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 9;
            continue;
        }
        else if(str.find("结合方式策略10") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 10;
            continue;
        }
        else if(str.find("结合方式策略11") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 11;
            continue;
        }
        else if(str.find("结合方式策略12") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 12;
            continue;
        }
        else if(str.find("结合方式策略13") != string::npos)
        {
            StrategyParam::useCombinedSysMethod  = 13;
            continue;
        }
        if (str.find("结合R策略0") != string::npos){
            StrategyParam::combinedRMode  = 0;
            continue;
        }
        else if(str.find("结合R策略1") != string::npos)
        {
            StrategyParam::combinedRMode  = 1;
            continue;
        }
        else if(str.find("结合R策略2") != string::npos)
        {
            StrategyParam::combinedRMode  = 2;
            continue;
        }
        else if(str.find("结合R策略3") != string::npos)
        {
            StrategyParam::combinedRMode  = 3;
            continue;
        }
        if (str.find("等词使用频度策略0") != string::npos){
            StrategyParam::equalityUsedFrq  = 0;
            continue;
        }
        else if(str.find("等词使用频度策略1") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 1;
            continue;
        }
        else if(str.find("等词使用频度策略2") != string::npos)
        {
            StrategyParam::equalityUsedFrq  = 2;
            continue;
        }       
        if(str.find("预处理结合策略0") != string::npos){
            StrategyParam::preprocess  = 1;
            continue;
        }
        else if(str.find("预处理结合策略1") != string::npos){
            StrategyParam::preprocess  = 0;
            continue;
        }
        if (str.find("浸透方法0") != string::npos){
            StrategyParam::useSaturate = true;
            continue;
        }
        else if(str.find("浸透方法1") != string::npos)
        {
            StrategyParam::useSaturate = false;
            continue;
        }
        if ((str.find("因子归结预处理") != string::npos)&&(str.find("不因子归结预处理") == string::npos)){
            StrategyParam::factorRes = true;
            continue;
        }
        else if(str.find("不因子归结预处理") != string::npos)
        {
            StrategyParam::factorRes = false;
            continue;
        }
         if ((str.find("等词归结预处理") != string::npos)&&(str.find("不等词归结预处理") == string::npos)){
            StrategyParam::eqnRes  = true;
            continue;
        }
        else if(str.find("不等词归结预处理") != string::npos)
        {
            StrategyParam::eqnRes  = false;
            continue;
        }
         if ((str.find("删除纯文字子句") != string::npos)&&(str.find("不删除纯文字子句") == string::npos)){
            StrategyParam::delPureCla  = true;
            continue;
        }
        else if(str.find("不删除纯文字子句") != string::npos)
        {
            StrategyParam::delPureCla  = false;
            continue;
        }
        if ((str.find("目标子句预处理") != string::npos)&&(str.find("不目标子句预处理") == string::npos)){
            StrategyParam::goalCla  = true;
            continue;
        }
        else if(str.find("不目标子句预处理") != string::npos)
        {
            StrategyParam::goalCla  = false;
            continue;
        }
        if (str.find("单元子句排序规则0") != string::npos){
            StrategyParam::unitSortRule = 0;
            continue;
        }
        else if (str.find("单元子句排序规则1") != string::npos){
            StrategyParam::unitSortRule = 1;
            continue;
        }
        else if (str.find("单元子句排序规则2") != string::npos){
            StrategyParam::unitSortRule = 2;
            continue;
        }
        else if (str.find("单元子句排序规则3") != string::npos){
            StrategyParam::unitSortRule = 3;
            continue;
        }
        else if (str.find("单元子句排序规则4") != string::npos){
            StrategyParam::unitSortRule = 4;
            continue;
        }
        else if (str.find("单元子句排序规则5") != string::npos){
            StrategyParam::unitSortRule = 5;
            continue;
        }
        else if (str.find("单元子句排序规则6") != string::npos){
            StrategyParam::unitSortRule = 6;
            continue;
        }
        else if (str.find("单元子句排序规则7") != string::npos){
            StrategyParam::unitSortRule = 7;
            continue;
        }
        else if (str.find("单元子句排序规则8") != string::npos){
            StrategyParam::unitSortRule = 8;
            continue;
        }
        if (str.find("子句综合函数复杂度-1") != string::npos){
             StrategyParam::claFuncComp = -1;
             StrategyParam::funcFixDeepth = 36;
            continue;
        }
        else if (str.find("子句综合函数复杂度0") != string::npos){
             StrategyParam::claFuncComp = 0;
             StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 1;
            continue;
        }
        else if (str.find("子句综合函数复杂度1") != string::npos){
            StrategyParam::claFuncComp = 1;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + StrategyParam::funcOrgFixDeepthLessMax;
            continue;
        }
        else if (str.find("子句综合函数复杂度2") != string::npos){
            StrategyParam::claFuncComp = 2;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*2;
            continue;
        }
        else if (str.find("子句综合函数复杂度3") != string::npos){
            StrategyParam::claFuncComp = 3;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax*3;
            continue;
        }
        else if (str.find("子句综合函数复杂度4") != string::npos){
            StrategyParam::claFuncComp = 4;
            StrategyParam::funcFixDeepth = StrategyParam::funcOrgFixDeepthMax + 10;
            continue;
        }
        if (str.find("单元子句更换方式0") != string::npos){
             StrategyParam::unitClaUpdate = 0;
            continue;
        }
        else if (str.find("单元子句更换方式1") != string::npos){
             StrategyParam::unitClaUpdate = 1;
            continue;
        }else if (str.find("单元子句更换方式2") != string::npos){
             StrategyParam::unitClaUpdate = 2;
            continue;
        }
       if (str.find("非单元子句之间归结") != string::npos){
            StrategyParam::noUnitRes = true;
            continue;
        }
        else if(str.find("非单元子句之间不归结") != string::npos)
        {
            StrategyParam::noUnitRes = false;
            continue;
        }
        if (str.find("非单元子句约简与结论判断") != string::npos){
            StrategyParam::noUnitSimplify = true;
            continue;
        }
        else if(str.find("非单元子句约简与结论不判断") != string::npos)
        {
            StrategyParam::noUnitSimplify = false;
            continue;
        }
        if ((str.find("拆分三角形输出") != string::npos)&&(str.find("不拆分三角形输出") == string::npos)){
            StrategyParam::divideTri = true;
            continue;
        }
        else if(str.find("不拆分三角形输出") != string::npos)
        {
            StrategyParam::divideTri = false;
            continue;
        }
        if ((str.find("删除无法判定记录:") != string::npos)&&(str.find("不删除无法判定记录:") == string::npos)){
            StrategyParam::delRecord = true;
            continue;
        }
        else if(str.find("不删除无法判定记录:") != string::npos)
        {
            StrategyParam::delRecord = false;
            continue;
        }
        if ((str.find("优先生成文字少的子句:") != string::npos)&&(str.find("不优先生成文字少的子句:") == string::npos)){
            StrategyParam::genLitClause = true;
            continue;
        }
        else if(str.find("不优先生成文字少的子句:") != string::npos)
        {
            StrategyParam::genLitClause = false;
            continue;
        }
        if (str.find("多组合策略模式0") != string::npos){
            StrategyParam::strategyMode = 0;
            continue;
        }
        else if (str.find("多组合策略模式1") != string::npos){
            StrategyParam::strategyMode = 1;
            continue;
        }
        else if (str.find("多组合策略模式2") != string::npos) {
            StrategyParam::strategyMode = 0;
            continue;
        }
        if (str.find("非单元子句限制策略0") != string::npos){
            StrategyParam::noUintCla = 0;
            continue;
        }
        else if (str.find("非单元子句限制策略1") != string::npos){
            StrategyParam::noUintCla = 1;
            continue;
        }
        else if (str.find("非单元子句限制策略2") != string::npos){
            StrategyParam::noUintCla = 2;
            continue;
        }
        else if (str.find("非单元子句限制策略3") != string::npos){
            StrategyParam::noUintCla = 3;
            continue;
        }
        else if (str.find("非单元子句限制策略4") != string::npos){
            StrategyParam::noUintCla = 4;
            continue;
        }
        else if (str.find("非单元子句限制策略5") != string::npos){
            StrategyParam::noUintCla = 5;
            continue;
        }
        else if (str.find("非单元子句限制策略6") != string::npos){
            StrategyParam::noUintCla = 6;
            continue;
        }
        else if (str.find("非单元子句限制策略7") != string::npos){
            StrategyParam::noUintCla = 7;
            continue;
        }
        else if (str.find("非单元子句限制策略8") != string::npos){
            StrategyParam::noUintCla = 8;
            continue;
        }
        if (str.find("目标深度模式0") != string::npos){
            StrategyParam::goalDeepth = 2;
            continue;
        }
        else if (str.find("目标深度模式1") != string::npos){
            StrategyParam::goalDeepth = 3;
            continue;
        }
        else if (str.find("目标深度模式2") != string::npos){
            StrategyParam::goalDeepth = 4;
            continue;
        }
        else if (str.find("目标深度模式3") != string::npos){
            StrategyParam::goalDeepth = 5;
            continue;
        }
        else if (str.find("目标深度模式4") != string::npos){
            StrategyParam::goalDeepth = 6;
            continue;
        }
        else if (str.find("目标深度模式5") != string::npos){
            StrategyParam::goalDeepth = 7;
            continue;
        }
        else if (str.find("目标深度模式6") != string::npos){
             StrategyParam::goalDeepth = 8;
            continue;
        }
        else if (str.find("目标深度模式7") != string::npos){
            StrategyParam::goalDeepth = 9;
            continue;
        }
        else if (str.find("目标深度模式8") != string::npos){
             StrategyParam::goalDeepth = 10;
            continue;
        }
        else if (str.find("目标深度模式9") != string::npos){
            StrategyParam::goalDeepth = 200;
            continue;
        }
        if (str.find("锁子句约简模式0") != string::npos){
            StrategyParam::lockType = 1;
            continue;
        }
        else if (str.find("锁子句约简模式1") != string::npos){
            StrategyParam::lockType = 2;
            continue;
        }
        else if (str.find("锁子句约简模式2") != string::npos){
            StrategyParam::lockType = 3;
            continue;
        }
        else if (str.find("锁子句约简模式3") != string::npos){
            StrategyParam::lockType = 4;
            continue;
        }
        else if (str.find("锁子句约简模式4") != string::npos){
            StrategyParam::lockType = 5;
            continue;
        }
        else if (str.find("锁子句约简模式5") != string::npos){
            StrategyParam::lockType = 0;
            continue;
        }
        if (str.find("冗余判断策略0") != string::npos){
            StrategyParam::termReRedund = true;
            continue;
        }
        else if (str.find("冗余判断策略1") != string::npos){
            StrategyParam::termReRedund = false;
            continue;
        }
    }
    fclose(fd);
}

void FileOp::insertInfo(string str ,double time_s,UINT32 triTotalTimes)
{
    string strInfoPath = g_OutputPath + "/" + JudgeFileFullNameNoExt + ".info";
    ifstream ifFolFile(strInfoPath);
    vector<string> info;
    string strClause;
    while (getline(ifFolFile, strClause)) {
        info.push_back(strClause);
    }
    ifFolFile.close();
    remove(strInfoPath.c_str());
    PrintINFO(str);
    char saveTime[100];
    sprintf(saveTime,"%f",time_s);
    string strTime = "判定时间："+string(saveTime)+"秒";
    PrintINFO(strTime);
    char saveTimes[100];
    sprintf(saveTimes,"%u",triTotalTimes);
    string triTimes = "矛盾体个数："+ string(saveTimes);
    PrintINFO(triTimes);
    strClause = "****************";
    PrintINFO(strClause);
    for(UINT32 i = 0 ; i<info.size();i++)
        PrintINFO(info[i]);
}

void FileOp::copyAndDelOrgFile(string orgFile, string theoremFormat){
    ifstream fin(orgFile.c_str());   
    size_t pos = orgFile.find_last_of('/');
    string strategyName = orgFile.substr(pos + 1);
    size_t posEnd = strategyName.find_last_of('.');
    string strategyNameNoExt = strategyName.substr(0, posEnd);
    string distFile = workSpace + "/unsat/" + strategyNameNoExt + "_" + JudgeFileFullNameNoExt + ".txt";
    ofstream fout(distFile.c_str());
    char str;
    while (fin.get(str)) {
        fout << str;
    }
    fin.close();
    fout.close();
    string strategyRecordFile = workSpace + "/unsat" + "/strategyRecord.txt";
    strategyRecord = new ofstream(strategyRecordFile.c_str(), ios::app);
    if(theoremFormat == "0")
        *strategyRecord << judgeOriginalFileName + ": " + distFile << endl;
    else
        *strategyRecord << JudgeFileFullNameNoExt + ": " + distFile << endl;
    strategyRecord->close();
}
