/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef FILEOP_H
#define FILEOP_H
#include "Clause.h"
#include "Literal.h"
#include "Term.h"
#include "globalFunc.h"
#include "dataTypeDef.h"

class FileOp {
public:
    static FILETYPE fileType;
    static string homePath;
    static string strategyFile;
    static int strategyFileSize;
    static int strategyMode;
    static int runMode; 
    static UINT32 runFileId;
    static UINT32 outPutRCount;
    static string judgeOriginalFileFullName;
    static string judgeOriginalFileName;
    static string JudgeFileFullName; 
    static string JudgeFileName;
    static string JudgeFileFullNameNoExt;
    static string JudgeFileDir;
    static string JudgeFileResult;
    static ofstream *ofJudgeFileResult;
    static ofstream *ofJudgeAllFileResult;
    static ofstream *ofSingleEndUnitCla;
    static ofstream *ofNouseCla;
    static vector<string> StrategyfileName;
    static vector<string> StrategyCorrespondingFilePath;
    static INT32 runFileNum;
    FileOp();
    FileOp(const FileOp& orig);
    virtual ~FileOp();
    static void getTopPath(bool useVersion);
    static RESULT AnalysisFileName(string str);
    static bool isExistDir(string strDir);
    static bool isExistProof(string strDir);
    static void CreateResultFile();
    static bool CreateTotalOutputFile(bool parseTime);
    static string g_FileDir;	
    static string g_WorkDir;
    static string g_PreFileFullName; 
    static string g_OutputPath;
    static string appPath;
    static string workSpace;
    static ofstream *ofRealInfoOut;
    static ofstream *ofLogOut;
    static ofstream *ofPathOut;
    static ofstream* ofOutput;
    static ofstream* ofProofComp;
    static ofstream* strategyRecord;
    bool static CreateRunInfoFile(UINT32 StartId);
    bool static   CreateRunInfoFilePre(UINT32 StartId );
    static void PrintINFOEndRSinglePre(string& msg);
    static void PrintINFONoUsePre(string& msg);
    bool static CreateLogFile();
    static string getFilePath(string &fileFullName);
    static string getFileName(string &fileFullName);
    static string getFileNameNoExt(string fileFullName);
    static void ReleaseOf();
    static void outReleaseOf();
    static RESULT FilePathAnaysis(const string& fileFullName);
    static void PrintINFORSinglePre(string& msg);
    static void PrintINFORSinglePreAfter(string& msg);
    static void PrintINFORPre(string& msg);
    static void PrintINFORPreAfter(string& msg);
    static void LogOut(const string& msg);
    static void PrintINFO(string&msg);
    static void WritePreFile(const string& str);
    static void RInvaildInfoOut(string& rundMsg, INT32 StartId);
    static void RInvaildInfoOutPath(string& rundMsg, INT32 StartId);
    static void RunInfoOut(vector<Literal*>&vOptTri, Clause* newCla, INT32 StartId, vector<string>*strOptTris);
    static void WriteTriPath(string& str);
    static void WriteR(Clause*newCla);
    static void OperDir(string src,vector<string>* fileName );
    static bool isFileEmpty(string filePath);
    static void OperStrategy(string src,vector<string>* fileName);
    static void readCorrespondingStrategy(string src,vector<string>* fileName);
    static void packageCorrespondingStrategyAndSaveBinary(string src, vector<string>* fileName);
    static void packageCorrespondingStrategyAndCheck(string src);
    static bool findPackageCorrespondingStrategy(string src, string searchCorrespondingStrategies);
    static void findCorrespondingStrategy(string src, string searchCorrespondingStrategies);
    static void setSingleCorrespondingStrategy(string str);
    static int strategyFileSizeFunc(string src);
    static string findStrategy(string path, int len);
    static string findStrategyTptp(string path, int len);
    static void delRes();
    static void delRunFiles();
    static void delAllFiles();
    static void delAllFilesComplete(string filePath);
    static long getMem();
    static void getRes(int res[3]);
    static void insertInfo(string str,double time,UINT32 triTotalTimes);
    static void copyAndDelOrgFile(string orgFile, string theoremFormat);
    static void readStrategy();
    static void readBatchStrategy(string path);
    static void readStrategyN(int n);
    static void readStrategyNTptp(int n);
    static string getStrategyNTptp(int n);
    static void clearRes();
    static bool delCreateRunInfoFile(UINT32 StartId );
    static void PrintINFOEndRSinglePreNoUse(string& msg);
    static void prinfResForE(string& msg);
    static void prinfPreResForE(string& msg);
private:

};

#endif /* FILEOP_H */

