/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef RESOLUTION_H
#define RESOLUTION_H
#include "Formula.h"
#include "Subsumption.h"
#include "TriAlg.h"
#include "dataTypeDef.h"
#include "globalFunc.h"
class Resolution {
public:
    Resolution();
    Resolution(const Resolution& orig);
    ~Resolution() {
    };
    int demodulatorClaSet(Formula& fol,TriAlg& triAlg,UINT32& uNewClaID,vector<Clause*>* preGenCla,UINT32 simplyIdStart,UINT32 simplyIdEnd);
    int demodulatorCla(Formula& fol,TriAlg& triAlg,Clause* cla,UINT32& uNewClaID,vector<Clause*>* preGenCla);
    int demodulatorClaSaturate(Formula& fol,TriAlg& triAlg,Clause* cla,UINT32& uNewClaID,vector<Clause*>* preGenCla);
    int demodulatorLit(Formula& fol,TriAlg& triAlg,Literal* lit,UINT32& uNewClaID,vector<Clause*>* eqnLit);
    int demodulatorLitSaturate(Formula& fol,TriAlg& triAlg,Literal* lit,UINT32& uNewClaID,vector<Clause*>* eqnLit);
    int demodulatorTerm(Formula& fol,TriAlg& triAlg,Term* term,UINT32& uNewClaID,vector<Clause*>* eqnLit);
    int demodulatorTermSaturate(Formula& fol,TriAlg& triAlg,Term* term,UINT32& uNewClaID,vector<Clause*>* eqnLit);
    int negEqnRes(Formula& fol,TriAlg& triAlg,Clause* cla,UINT32& uNewClaID,vector<Clause*>* preGenCla,bool fileNameFlag);
    int factorRes(Formula& fol,TriAlg& triAlg,Clause* cla,UINT32& uNewClaID,vector<Clause*>* preGenCla,bool& resDelFlag, bool fileNameFlag);
    RESULT BaseAlgByRecodePath(Formula &fol, UINT64 &triTotalTimes);
    RESULT InsertSingleSet(Formula& fol,TriAlg& triAlg,int& maxUintID);
    RESULT InsertSingleSetSaturate(Formula& fol, TriAlg& triAlg);
    RESULT InsertSingleCla(Formula& fol, Clause* clap);
    void shiftSingleCla(vector<Literal*>& orgSingleCla, UINT32 N);
    RESULT InsertOutTri(TriAlg& triAlg, Formula& fol, UINT16& loop, bool chooseTri);
    RESULT InsertOutTriLR(TriAlg& triAlg, Formula& fol, UINT16& loop, bool chooseTri);
    RESULT BaseAlgByRecodePathSaturate(Formula& fol, UINT64 &triTotalTimes); 
    void insertNoPairCla(Formula& fol, Clause* cla);
    double timeConsume(TriAlg& triAlg);
    bool lockResSimlify(Formula& fol,TriAlg& triAlg,Clause* cla,UINT32& uNewClaID);
    bool lockResSimlifyNew(Formula& fol,TriAlg& triAlg,Clause* cla,UINT32& uNewClaID);
    int JudgeLockResSimlify(Formula& fol,TriAlg& triAlg,Literal* QLit,Literal* candLitp,vector<Literal*>& candLitPVec,UINT32& uNewClaID,UINT8 lockType,vector<Term*>& VarVec);
    int JudgeLockResSimlifyNew(Formula& fol,TriAlg& triAlg,Literal* QLit,Literal* candLitp,vector<Literal*>& candLitPVec,UINT32& uNewClaID,UINT8 lockType,vector<Term*>& VarVec);
private:
    UINT32 runNum;
    INT32 StartId;
    UINT32 shift;
    UINT32 ringCount;
    Clause* startClause;
    UINT8 triAlgTimes;
    bool difficulty;
    UINT32 noPairInd;
    Clause* noPairCla;
    vector<Term*> varBindTerm;
    vector<Literal*> lockLitVec;
    vector<Clause*> lockClaVec;
};

#endif /* RESOLUTION_H */

